const path = require('path');
const cors = require('koa2-cors');
const isDev = think.env === 'development';
const bodyParser = require('koa-bodyparser');
const koaBody = require('koa-body');

module.exports = [
  {
    handle: cors,
    options: {}
  },
  {
    handle: bodyParser,
    match: /^\/upload/,
    options: {}
  },
  {
    handle: koaBody,
    match: /^\/upload/,
    options: {
      multipart: true,
      formidable: {
        maxFileSize: 200 * 1024 * 1024    // 设置上传文件大小最大限制，默认200M
      }
    }
  },
  {
    handle: koaBody,
    match: /^\/letters\/uploadLetters/,
    options: {
      multipart: true,
      formidable: {
        maxFileSize: 200 * 1024 * 1024    // 设置上传文件大小最大限制，默认200M
      }
    }
  },
  {
    handle: koaBody,
    match: /^\/activity\/uploadOcr/,
    options: {
      multipart: true,
      formidable: {
        maxFileSize: 200 * 1024 * 1024    // 设置上传文件大小最大限制，默认200M
      }
    }
  },
  {
    handle: koaBody,
    match: /^\/letters\/lettersUpdate/,
    options: {
      multipart: true,
      formidable: {
        maxFileSize: 200 * 1024 * 1024    // 设置上传文件大小最大限制，默认200M
      }
    }
  },
  {
    handle: 'meta',
    options: {
      logRequest: isDev,
      sendResponseTime: isDev
    }
  },
  {
    handle: 'resource',
    enable: isDev,
    options: {
      root: path.join(think.ROOT_PATH, 'www'),
      publicPath: /^\/(static|favicon\.ico)/
    }
  },
  {
    handle: 'trace',
    enable: !think.isCli,
    options: {
      debug: isDev,
      templates: {
        400: path.join(think.ROOT_PATH, 'view/404.html'),
        403: path.join(think.ROOT_PATH, 'view/404.html'),
        404: path.join(think.ROOT_PATH, 'view/404.html'),
        500: path.join(think.ROOT_PATH, 'view/404.html'),
        503: path.join(think.ROOT_PATH, 'view/404.html')
      }
    }
  },
  {
    handle: 'payload',
    options: {
      keepExtensions: true,
      limit: '5mb'
    }
  },
  {
    handle: 'router',
    options: {}
  },

  'logic',
  'controller'
];
