const Base = require('./base.js');
const moment = require('moment');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  // 异常预警信息列表
  async getListAction(){
    let data = this.post();
    let where = {
      "createOrgID":data.orgID
    };
    // 时间区间
    if (data.hasOwnProperty('startTime') && data.startTime !== ''){
      where["createTime"] = ['>',moment(data.startTime).format('YYYY-MM-DD')];
    }
    if (data.hasOwnProperty('endTime') && data.endTime !== ''){
      where["CreateTime"] = ['<',moment(data.endTime).add(1,'day').format('YYYY-MM-DD')];
    }
    if (data.hasOwnProperty('apply')) {
      // apply 1 已审核  0 未审核
      if (data.apply === 1){
        where["applyTime"] = ['!=',null]
      }
      if (data.apply === 0){
        where["applyTime"] = null
      }
    }
    let back = await this.model('abnormal').where(where)
      .order('createTime Desc').page(data.page, data.pageSize).countSelect();
    return this.success(back)
  }

  // 管理员处理异常信息
  async applyAction(){
    let data = this.post();
    let userInfo = await this.getUserInfo(data.userId);
    let upData = {
      "applyUserId":data.userId,
      "applyName":userInfo.name,
      "applyTime":moment().format('YYYY-MM-DD HH:mm:ss'),
      "remark":data.remark,
    };
    await this.model('abnormal').where({'id':data.id}).update(upData);
    return this.success();
  }
};

