const Base = require('./base.js');
const moment = require('moment');
module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  /**
   * showdoc
   * @catalog 审计日志
   * @title 审计日志列表
   * @description 审计日志列表接口
   * @method post
   * @url http://127.0.0.1:8360/audit/search
   * @param userId 必选 string 创建人员id
   * @param startTime 非必选 string 开始时间YYYY-MM-DD
   * @param endTime 非必选 string 结束时间
   * @param name 非必选 string 被搜索人姓名
   * @param page 必选 int 页码
   * @param limit 必选 int 每页条数
   * @return {"errno": 0, "errmsg":"", "data":{}}
   */
  async searchAction(){
    let data = this.post();
    let where = {};
    if (data.hasOwnProperty('startTime') && data.startTime !== '') {
      where['time'] = ['>=',moment(data.startTime).format('YYYY-MM-DD')]
    }
    if (data.hasOwnProperty('endTime') && data.endTime !== '') {
      where['TIME'] = ['<',moment(data.endTime).add(1, 'day').format('YYYY-MM-DD')]
    }
    if ((!data.hasOwnProperty('startTime') && !data.hasOwnProperty('endTime')) || (data.startTime === '' && data.endTime === '')) {
      where['time'] = ['between', moment().format('YYYY-MM-DD') + ',' + moment().add(1, 'day').format('YYYY-MM-DD')]
    }
    if (data.hasOwnProperty('name') && data.name !== '') {
      where['name'] = ['LIKE','%'+ data.name +'%']
    }
    let back = await this.model('audit_log').where(where).page(data.page, data.limit).order('time DESC').countSelect()
    return this.success(back)
  }
};
