const Base = require('./base.js');
const upload = require('./../handle/uploadFile')
const template = require('./../handle/template');
const moment = require('moment');
const fs = require('fs');
const path = require('path');
const util = require('./../handle/util');
const idCard = require('./../handle/idCard');


module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  // 拟函假接口
  async testAction() {
    // const json = {
    //   'title': '',
    //   'titleColor': 'red',
    //   'text': '现将安徽省人大代表张庆转来信访人徐斌的信访事项转给你们，请交相关部门研究办理。办理结果答复信访人、反馈代表，并函告我单位。',
    //   'rider': '附：信访材料（含联系方式）',
    //   'finalDisposal': '合肥市人大常委会',
    //   'host': '安徽省人大常委会',
    //   'letterCode': '访转（2020）113号',
    //   'time': '2020年4月30日',
    // }


    // const back = await idCard.check('张2庆','34010419701002151X');
    // console.log(back)
    // this.success(back)
    //     const json = await this.model('node_record').where({'id':1}).find();
    //     console.log(typeof json)
    //     console.log(typeof json.info)
    //     console.log(JSON.parse(json.info).taskid)
    // console.log(this.file().file);
    // console.log(this.file().file.name);
  //   console.log(this.file().url); // undefined
  //   console.log(this.post().url);
  //   const matter = await this.model('matter').setRelation(false).alias('m').field('m.*, sd.type as deptType')
  //     .join({table:'sys_dept', join:'left', on:['finalZoneID', 'id'],as:'sd'}).where({'m.id':"16589381-d5fc-11ea-9c1a-33f5b4e9239b"}).find()
  //   return this.success(matter)
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 待拟函列表
   * @description 待拟函列表接口
   * @method post
   * @url http://127.0.0.1:8360/letters/waitList
   * @param userId 必选 string userId
   * @return {"errno": 0, "errmsg":""}
   */
  // 待拟函列表
  async waitListAction(){
    const data = this.post();
    // 账号信息
    const account = await this.getUserJurisdiction(data.userId);
    // let acc = account.nextAccount; // 下属账号
    // acc.push(account.selfAccount); // +自己账号
    const matter = await this.model('matter').where({'state':4,'createAccount':account.selfAccount})
      .page(data.page, data.limit).order('createTime DESC').countSelect();
    return this.success(matter);
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 函件待审批
   * @description 函件待审批接口
   * @method post
   * @url http://127.0.0.1:8360/letters/waitApproval
   * @param userId 必选 string userId
   * @param startTime 必选 string 开始时间YYYY-MM-DD
   * @param endTime 必选 string 结束时间YYYY-MM-DD
   * @return {"errno": 0, "errmsg":""}
   */
  // 函件待审批列表（已拟函）
  async waitApprovalAction(){
    const data = this.post();
    let where;
    // 账号信息
    const account = await this.getUserJurisdiction(data.userId);
    if (account.isLead === 0) {
      // 不是领导
      where = {'state':6,'createAccount':account.selfAccount}
    }else {
      where = {'state':6,'createAccount':['IN',account.nextAccount]}
    }
    // 时间
    if (data.startTime === '' && data.endTime === ''){
      // 默认当天
      where['createTime'] = ['between', moment().format('YYYY-MM-DD') + ',' + moment().add(1, 'day').format('YYYY-MM-DD')]
    } else if (data.startTime === ''){
      // 未设定开始时间
      where['createTime'] = ['between', '1900-01-01' + ',' + moment(data.endTime).add(1, 'day').format('YYYY-MM-DD')]
    } else if (data.endTime === ''){
      // 未设定结束时间
      where['createTime'] = ['between', moment(data.startTime).format('YYYY-MM-DD') + ',' + '2099-01-01']
    } else {
      where['createTime'] = ['between', moment(data.startTime).format('YYYY-MM-DD') + ',' + moment(data.endTime).add(1, 'day').format('YYYY-MM-DD')]
    }
    const matter = await this.model('matter').where(where).page(data.page, data.limit).order('createTime DESC').countSelect();
    return this.success(matter);
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 生成函件
   * @description 生成函件接口
   * @method post
   * @url http://127.0.0.1:8360/letters/create
   * @param userId 必选 string userId
   * @param matterID 必选 string 事项id
   * @param isRD 必选 int 是否是人大自办。0否，1是
   * @return {"errno": 0, "errmsg":""}
   */
  // 生成函件
  async createAction(){
    const data = this.post();
    // isRD默认为0
    // 获取函件模板
    const temp = await template.getTemplateAndReplace(data.matterID,data.isRD,data.userId);
    if (think.isEmpty(temp)){
      // 获取模板失败
      return this.fail("获取模板失败!");
    } else {
      const matter = await this.model('matter').where({'id':data.matterID}).find();
      const userInfo = await this.getUserInfo(data.userId);
      // 生成函号
      // const code = await util.letterNum(userInfo.depJc,userInfo.orgJc,'信函字'); // 此处要求函号要最后生成
      let template = {
        'title': userInfo.deptTitle,// 自行设置的函件标题
        'titleColor': temp.titleColor,
        'text': temp.text,
        'rider': temp.rider,
        'finalDisposal': matter.finalZone + matter.finalDisposal,// 去向单位 地区+单位
        'host': userInfo.deptName, // 署名
        // 'letterCode': code,
        'letterCode': '',
        'time': moment().format('YYYY年M月D日'),
        'phone':userInfo.phone
      };
      this.success(template)
    }
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 上传函件
   * @description 上传函件formData接口
   * @method post
   * @url http://127.0.0.1:8360/letters/uploadLetters
   * @param userId 必选 string userId
   * @param matterID 必选 string 事项id
   * @return {"errno": 0, "errmsg":""}
   */
  // 上传函件
  async uploadLettersAction(){
    const data = this.ctx;
    const body = data.request.body;
    const userInfo = await this.getUserInfo(body.userId);
    // 上传文件
    const res = upload.uploadFile(data);

    const matter = await this.model('matter').where({'id':body.matterID}).find()
    // 将文件路径存到matter_file
    const add = {
      'matterID':body.matterID,
      'url':res,
      'upAccount':userInfo.user_name,
      'type':"函件",
      'time':moment().format('YYYY-MM-DD HH:mm:ss'),
      'nextDepartment':matter.finalDisposal, // 接收单位
      'nextDepartmentID':matter.finalDisposalID,
      'nextRegion':matter.finalZone,// 接收地区
      'region':userInfo.description,// 发送地区
      'department':userInfo.orgName,// 发送单位
      'departmentID':userInfo.orgID
    };
    const addFile = await this.model('matter_file').add(add);
    // 更新matter表状态为待审批
    const matterUp = await this.model('matter').where({'id':body.matterID}).update({'state':6}); // 状态6仅仅针对函件
    const activity = await this.model('activity').where({'matterID':['like', '%' + body.matterID + '%']}).find()
    // 插入matter_state表
    const stateAdd = {
      'matterID': data.matterID,
      'activityID': data.activityID,
      'mainPersonID': activity.mainPerson, //主信访人
      'state': 6,
      'stateName': '函件待审批',
      'nextState': 8, // 判断办理方式
      'nextStateName': '函件待发送',
      'departmentID': userInfo.orgID,
      'department': userInfo.orgName, // 机构
      'description': userInfo.description, // 地区
      'dictValue': userInfo.dictValue,
      'handlePerson': userInfo.name,
      'handlePersonID': userInfo.user_name,
      'nextDepartment': userInfo.orgID, // 去向单位 （下一步操作还是本单位）
      'nextDepartmentID': userInfo.orgName
    };
    const matter_state = await this.model('matter_state').add(stateAdd);
    // 提交函件审批
    const approvalAdd = {
      'state': 0,
      'typeID': 3, // 拟函
      'type': '拟函', // 拟函
      'eventID': data.matterID,
      'createTime': moment().format('YYYY-MM-DD HH:mm:ss'),
      'auditee':userInfo.name,//被审核人（提交人）
      'auditeeAccount': userInfo.user_name // 考虑到工作人员跟领导可能是同一个人
    };
    const approval = await this.model('approval').add(approvalAdd);
    // 推进流程
    const param = {
      "taskId":data.taskid,
      "userId":data.userId,
      "regionLevel":userInfo.deptLevel === 0 ? '省级' : (userInfo.deptLevel === 1 ? '市级': '县级'),
      "deptID":userInfo.orgID, // 去向单位id
      "deptName":userInfo.orgName, // 去向单位名称
      "dealtype":'' // 下一步办理方式
    };
    if (data.hasOwnProperty('businessId')){
      param['businessId'] = data.businessID
    }
    await httpRequest('post','http://localhost:8360/flow/service/taskForward',param);
    this.success(addFile);
  };
  /**
   * showdoc
   * @catalog 函件信息
   * @title 函件列表
   * @description 函件列表接口
   * @method post
   * @url http://127.0.0.1:8360/letters/list
   * @param userId 必选 string userId
   * @param state 必选 int 4待拟函，6待审核，8待发送，7待修改
   * @return {"errno": 0, "errmsg":""}
   */
  // 函件待发送列表
  async listAction(){
    const data = this.post();
    // 账号信息
    const account = await this.getUserJurisdiction(data.userId);
    // let acc = account.nextAccount; // 下属账号
    // acc.push(account.selfAccount); // + 自己账号
    const matter = await this.model('matter').where({'state':data.state,'createAccount':account.selfAccount})
      .page(data.page, data.limit).order('createTime DESC').countSelect();
    this.success(matter);
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 函件审批
   * @description 函件审批接口
   * @method post
   * @url http://127.0.0.1:8360/letters/approval
   * @param matterID 必选 string 事项ID
   * @param handleModelID 必选 string 办理方式ID
   * @param userId 必选 string userId
   * @param nextDepartment 必选 string 去向单位
   * @param nextDepartmentID 必选 string 去向单位编号
   * @param opinion 必选 int 审批意见，0通过，1不通过
   * @param content 必选 string 审批意见
   * @return {"errno": 0, "errmsg":""}
   */
  // 函件审批
  async approvalAction(){
    const data = this.post();
    let userInfo = await this.getUserInfo(data.userId); // 获取用户信息
    const approvalUp = {
      'auditor': userInfo.name, // 审核人
      'auditorAccount': userInfo.user_name,
      'opinion': data.opinion, //审核操作0同意，1拒绝，2其他
      'remark': data.content, //审核意见
      'state': 1, //审核状态
      'auditTime': moment().format('YYYY-MM-DD HH:mm:ss'), //审核时间
    };
    const approval = await this.model('approval').where({'eventID':data.matterID}).update(approvalUp);
      // 审批通过，修改matter表状态
    const matter = await this.model('matter').where({'id':data.matterID}).update({'state':(data.opinion === 0 ? 8 : 7)});
    const activity = await this.model('activity').where({'matterID':['like', '%' + data.matterID + '%']}).find();
    // 插入matter_state
    const stateAdd = {
      'matterID': data.matterID,
      'activityID': data.activityID,
      'mainPersonID': activity.mainPerson, //主信访人
      'state': data.opinion === 0 ? 8 : 7,//判断审核是否通过
      'stateName': data.opinion === 0 ? '函件待发送' : '函件待修改',
      'nextState': data.opinion === 0 ? 9 : 6, // 通过，代签收；不通过，待审核
      'nextStateName': data.opinion === 0 ? '代签收': '函件待审核',
      'departmentID': userInfo.orgID,
      'department': userInfo.orgName, // 机构
      'description': userInfo.description, // 地区
      'dictValue': userInfo.dictValue,
      'handlePerson': userInfo.name,//操作人员
      'handlePersonID': userInfo.user_name,
      'nextDepartment': data.opinion === 0 ? data.nextDepartment :userInfo.orgID, // 通过，这是去向单位，不通过，还是本单位
      'nextDepartmentID': data.opinion === 0 ? data.nextDepartmentID : userInfo.orgName,
    };
    const state = await this.model('matter_state').add(stateAdd);
    if (data.opinion === 0){
      //函件审批通过，修改函件状态为不需要审核状态
      const matter_file = await this.model('matter_file').where({
        'matterID':data.matterID,'nextDepartmentID':data.nextDepartmentID,'examine':1,'departmentID':userInfo.orgID
      }).update({'examine':0})
      // 推进流程
      //同意，下一步
      const param = {
        "taskId":data.taskid,
        "userId":data.userId,
        "regionLevel":userInfo.deptLevel === 0 ? '省级' : (userInfo.deptLevel === 1 ? '市级': '县级'),
        "deptID":userInfo.orgID, // 去向单位id
        "deptName":userInfo.orgName, // 去向单位名称
        "dealtype":data.handleModel // 下一步办理方式
      };
      if (data.hasOwnProperty('businessId')){
        param['businessId'] = data.businessID
      }
      await httpRequest('post','http://localhost:8360/flow/service/taskForward',param);
    }
    // 推进流程
    if(data.opinion === 1){
      //拒绝，退回到上一步
      const param = {
        "taskId":data.taskid,
        "userId":data.userId,
      };
      await httpRequest('post','http://localhost:8360/flow/service/taskBackward',param);
    }
    this.success('审核成功!')
  }
  // 函件发送

  // 函件已发送列表

  // 待审核函件查询
  async lettersFindAction(){
    const data = this.post();
    let where = {
      'matterID':data.matterID,'type':'函件','examine':1
    };
    const matter_file = await this.model('matter_file').where(where).find();
    this.success(matter_file)
    // const oldFile = think.ROOT_PATH + '/www/' + '/static/txt/1c3d26a16cc0d.txt';
    // const newFile = think.ROOT_PATH +  '/www/' + '/static/OCR/123.txt'
    // fs.rename(oldFile, newFile, (err) => {
    //   if (err) throw err;
    // });
    // fs.unlink(newFile, function(err){
    //   if(err){
    //     throw err;
    //   }
    //   console.log('文件:'+newFile+'删除成功！');
    // })
    // try {
    //   // fs.unlinkSync(newFile);
    //   fs.unlink(newFile);
    //   console.log('已成功地删除文件');
    // } catch (err) {
    //   // 处理错误
    //   console.log(err)
    // }
    // const up = await this.model('letters_num').where({'year':2020}).increment({'num':1});
    // let userInfo = await this.getUserInfo(data.userId)
    // const code = await util.letterNum(userInfo.depJc,userInfo.orgJc,'信函字')
    // return this.success(code)

    // var rs = fs.createReadStream(this.ctx.request.files.file.path);
    // var ws = fs.createWriteStream(path.join(think.ROOT_PATH, '/www/','static/pdf/0f31c24548086.pdf'));
    // rs.pipe(ws);
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 函件修改上传
   * @description 函件修改上传formData接口
   * @method post
   * @url http://127.0.0.1:8360/letters/lettersUpdate
   * @param url 必选 string 函件地址
   * @param fileID 必选 int 函件id
   * @return {"errno": 0, "errmsg":""}
   */
  // 函件修改上传
  async lettersUpdateAction(){
    const data = this.ctx;
    const body = data.request.body;
    // 替换原文件
    var rs = fs.createReadStream(this.ctx.request.files.file.path);
    var ws = fs.createWriteStream(path.join(think.ROOT_PATH, '/www/',body.url));
    rs.pipe(ws);
    const matter_file = await this.model('matter_file').where({'id':body.fileID}).update({'time':moment().format('YYYY-MM-DD HH:mm:ss')});
    return this.success('上传成功！')
  }
  /**
   * showdoc
   * @catalog 函件信息
   * @title 其他附件上传
   * @description 其他附件上传form-data接口
   * @method post
   * @url http://127.0.0.1:8360/letters/upload
   * @param file 必选 string 附件key
   * @return {"errno": 0, "errmsg":""}
   */
  // 函件编号
  async uploadAction(){
    const file = this.file().file; // file 文件
    const data = this.post(); // post其他参数
    // 上传文件
    //获取后缀
    let fileType = file.name.substr( file.name.lastIndexOf(".") + 1);
    // 认可的文件类型
    // let arr = ['doc','docx','jpg','png','jpeg','pdf','zip','rar','jpg'];
    // if(arr.toString().indexOf(fileType.toLowerCase()) === -1) { // 字符串转为小写比较
    let arr = ['application/msword',// doc
      'application/vnd.openxmlformats-officedocument.wordprocessingml.document',// docx
      'image/jpeg',// jpeg
      'image/png',//png
      'application/pdf',//pdf
      'application/zip',// zip
      'application/x-zip',// zip
      'application/x-zip-compressed',// zip
      'application/x-rar-compressed',// rar
      'application/octet-stream'// 其他不可识别
    ];
    if(arr.indexOf(file.type.toLowerCase()) === -1) { // 字符串转为小写比较
      return this.fail("文件类型不支持！")
    }
    if (file.size > 50*1024*1024) {
      return this.fail("文件大小超过限制！")
    }
    //创建路径
    // let filePath = path.join(think.ROOT_PATH, '/www/static', fileType);
    let filePath = path.join(think.ROOT_PATH, '/www/static', moment().format('YYYY年')+'/'+moment().format('M月')+'/'+fileType);
    upload.mkdirsSync(filePath);// 创建文件夹（如果需要）
    let fileName = Math.random().toString(16).substr(2) + '.' + fileType;// 文件名称
    let _uploadFilePath = path.join(filePath, fileName);
    let saveTo = path.join(_uploadFilePath);
    const reader = fs.createReadStream(file.path);// 读取文件
    // 文件保存到指定路径
    reader.pipe(fs.createWriteStream(saveTo));
    // 在文件上传日志中保存记录
    let log = {
      "name":file.name,
      "random":fileName,
      // "url":'/static/'+ fileType + '/' + fileName,
      "url":'/static/' + moment().format('YYYY年')+'/'+moment().format('M月')+'/'+ fileType + '/' + fileName,
      "fileType":fileType,
      "userId":data.userId
    };
    await this.model('file_log').add(log);
    // return this.success('/static/'+ fileType + '/' + fileName)
    return this.success(log.url)
  }
  // 通过附件地址，查找附件上传记录
  async fileFindAction(){
    // 传参url
    const data = this.post();
    if (!data.hasOwnProperty("url")) {
      return this.fail(2001,"附件地址缺失")
    }
    const file = await this.model("file_log").where({"url":data.url}).find().catch((err) => {
      return think.isError(err) ? err : new Error(err);
    });
    if (think.isError(file)||think.isEmpty(file)) {
      return this.fail(2001, '查询失败')
    }
    return this.success(file);
  }
  // 无案由取号
  // userID
  // type 信字(省代会)/信函字(非省代会)/信督字(督办)  dictID = HJ
  // from 案件来源
  // isAnswer 是否需要回复（只做记录，不进流程
  // remark 备注
  // finalDisposal 去向单位
  // finalDisposalID 去向单位ID
  async getLetterNumAction(){
    const data = this.post();
    const userInfo = await this.getUserInfo(data.userId);
    // 先查询1分钟内，该用户有没有取号
    let numFind = await this.model('letters_num_query').where({'createAccount':userInfo.user_name,'createTime':['>',moment().add(-1,'minutes').format('YYYY-MM-DD HH:mm:ss')]}).select()
    if (think.isEmpty(numFind)){
      //一分钟内，该账户没有取号,则可以取
      let remarkData = {
        from: data.hasOwnProperty('from') ? data.from : "",
        isAnswer:data.hasOwnProperty('isAnswer') ? data.isAnswer : "",
        remark: data.hasOwnProperty('remark') ? data.remark : ""
      };
      let finalData = {
        finalDisposal: data.hasOwnProperty('finalDisposal') ? data.finalDisposal : "",
        finalDisposalID: data.hasOwnProperty('finalDisposalID') ? data.finalDisposalID : null,
      };
      let code = await util.letterNum(userInfo.depJc,userInfo.orgJc,data.type,userInfo.orgID);
      // 插入函件函号查询表
      await util.letterQuery(code,data.type,userInfo,0,remarkData,finalData);
      return this.success(code);
    } else {
      return this.fail(2004,'您在一分钟内已取号，请确认，避免重复取号！')
    }
  }
  // 函号列表
  // userId
  // letterNum 函号，模糊查询
  // page  分页
  // limit
  // 只查询本单位
  async letterNumListAction(){
    const data = this.post();
    const userInfo = await this.getUserInfo(data.userId);
    let where = {
      createOrgID:userInfo.orgID
    };
    if (data.hasOwnProperty('letterNum')){
      where['letterNum'] = ['LIKE','%'+data.letterNum+'%']
    }
    const list = await this.model('letters_num_query').where(where)
      .page(data.page, data.limit).order('createTime DESC').countSelect();
    for (let item of list.data){
      if (item.fileUrl === null){
        let history = await this.model('history').where({"taskId":item.taskId,"info":["LIKE","%"+ item.letterNum +"%"]}).order("id DESC").find();
        if (!think.isEmpty(history)){
          let info = JSON.parse(history.info);
          item.fileUrl = info.letter
        }
      }
    }
    return this.success(list);//
  }
  // 上传无案由拟函附件
  // 额外要上传函号 code
  async upFileAction(){
    const file = this.file().file; // file 文件
    const data = this.post(); // post其他参数
    // 上传文件
    //获取后缀
    let fileType = file.name.substr( file.name.lastIndexOf(".") + 1);
    if (file.size > 50*1024*1024) {
      return this.fail("文件大小超过限制！")
    }
    //创建路径
    // let filePath = path.join(think.ROOT_PATH, '/www/static', fileType);
    let filePath = path.join(think.ROOT_PATH, '/www/static', moment().format('YYYY年')+'/'+moment().format('M月')+'/'+fileType);
    upload.mkdirsSync(filePath);// 创建文件夹（如果需要）
    let fileName = Math.random().toString(16).substr(2) + '.' + fileType;// 文件名称
    let _uploadFilePath = path.join(filePath, fileName);
    let saveTo = path.join(_uploadFilePath);
    const reader = fs.createReadStream(file.path);// 读取文件
    // 文件保存到指定路径
    reader.pipe(fs.createWriteStream(saveTo));
    // 在文件上传日志中保存记录
    let userInfo = await this.getUserInfo(data.userId);
    let log = {
      // "name":file.name,
      "name":moment().format('YYYY年M月D日') + userInfo.orgName + ((data.businessID === 3 || data.businessID === 5) ? "交办函" : (data.businessID === 10 ? "劝返单" : "转交单")),
      "random":fileName,
      // "url":'/static/'+ fileType + '/' + fileName,
      "url":'/static/'+ moment().format('YYYY年')+'/'+moment().format('M月')+'/'+ fileType + '/' + fileName,
      "fileType":fileType,
      "userId":data.userId
    };
    await this.model('file_log').add(log);
    if (data.hasOwnProperty('code')) {
      await this.model('letters_num_query').where({"letterNum":data.code}).update({'fileUrl':log.url});
    }
    return this.success();
  }

  __after(){
    if (this.ctx.url === '/letters/lettersFind'){
      console.log(122121);
      console.log(this.ctx.response.body);//返回值
      console.log(this.post());
    }
  }
};
