const Base = require('./base.js');
const util = require('./../handle/util');
module.exports =  class extends Base {
  //获取事项列表
  async getMatterListAction() {
    const param = this.post();
    let whereParam = {}
    //事项状态
    if (param.state) {
      whereParam['mms.state'] = param.state
    }
    //活动和住信访人的关联查询
    let actPerson = await this.model('activity').alias('a').field('a.*,p.name as pName,p.id as pid').join('left join person as p on a.mainPerson=p.id').buildSelectSql();
    //事项状态和最新状态的关联查询
    let matterState = await this.model('matter_now_state').alias('mns').field('mns.*,ms.matterID').join('left join matter_state as ms on ms.id=mns.matterStateID').buildSelectSql();
    let res = await this.model('matter').alias('m').field('m.*,ap.pName,mms.state').join({
      table: actPerson,
      join: 'left',
      as: 'ap',
      on: ['activityID', 'id']
    }).join({
      table: matterState,
      join: 'left',
      as: 'mms',
      on: ['id', 'matterID']
    }).where(whereParam).page(param.page, param.pageSize).countSelect();
    return this.success(res)
  }

  //获取信访人的所有活动
  async getPersonAllActivityAction() {
    const param = this.post();
    let whereParam ={"a.id":['!=',null]}
    whereParam['pa.personID']=param.personID;
    const res = await this.model('activity').alias('a').field('a.*').setRelation(false)
      .join({table:'person_activity',join:'left', on: ['id','activityID'], as: 'pa'})
      .where(whereParam).select();
    return this.success(res);
  }

  //获取信访人所有的事项
  async getPersonAllMatterAction() {
    const param = this.post();
    let whereParam ={"m.matterNum":['!=','']}
    whereParam['pa.personID']=param.personID;
    const res = await this.model('matter').alias('m').field('m.*').setRelation(false)
      .join({table:'person_activity', join: "left", on: ['activityID', 'activityID'], as: 'pa'})
      .where(whereParam).select();
    return this.success(res);

  }
}
