const Base = require('./../base.js');
const moment = require('moment');

module.exports = class extends Base {
  // 接谈排号系统（大屏显示
  async queueAction(){
    let room = [];
    //   let sql = await this.model('meeting_session').order('createTime desc').limit(1).buildSelectSql();// 大会届次，meeting_session
    // let meetingRoom = await this.model('meeting_room')
    //   .join({table: sql, as: 's', join: 'left', on: ['meetingID', 'id']}).field('meeting_room.*').order('roomCode').select();
    let meeting_session = await this.model('meeting_session').order('createTime desc').find();
    let meetingRoom = await this.model('meeting_room').where({"meetingID":meeting_session.id}).order('roomCode').select();
    meetingRoom.forEach(function(item) {
      room.push({
        'roomID':item.id,
        'name':item.room,
        'shortName':item.roomShort,
        'roomCode':item.roomCode,
        'roomOrg':item.roomOrg,
        'roomOrgID':item.roomOrgID,
        'waiting':[],
        'talking':[],
      })
    });
    // let queue = await this.model('queue').join('matter on matter.id = queue.matterID')
    //   .join('fw_task on fw_task.id = matter.taskid').join('meeting_room on meeting_room.id = queue.roomID')
    //   .where({'fw_task.businessID':['IN',[34,35]]}).field('queue.*,fw_task.businessID').select();
    let queue = await this.model('fw_task').where({'businessID':['IN',[34,35]]}).field('businessID,id as taskID').select();
    queue = JSON.parse(JSON.stringify(queue));
    for (let q of queue){
      let back = await this.model('queue').join('matter on matter.id = queue.matterID').join('meeting_room on meeting_room.id = queue.roomID')
        .where({'matter.taskid':q.taskID}).order('queue.createTime DESC').field('queue.*').find();
      q['roomOrgID'] = back.roomOrgID;
      q['roomCodeNum'] = back.roomCodeNum;
      q['roomCode'] = back.roomCode;
    }
    let waiting = []; //排队中
    let talking = []; //接谈中
    queue.forEach(function(items) {
      if (items.businessID === 34) {
        waiting.push(items);
      }
      if (items.businessID === 35) {
        talking.push(items)
      }
    });
    for (let r of room){
      for (let w of waiting){
        if (r.roomOrgID === w.roomOrgID){
          r.waiting.push({
            'codeNum':w.roomCode + w.roomCodeNum
          })
        }
      }
      for (let t of talking){
        if (r.roomOrgID === t.roomOrgID){
          r.talking.push({
            'codeNum':t.roomCode + t.roomCodeNum
          })
        }
      }
    }
    let call = await this.model('queue').join('matter on matter.id = queue.matterID')
      .join('fw_task on fw_task.id = matter.taskid').join('meeting_room on meeting_room.id = queue.roomID')
      .where({'fw_task.businessID':35,'fw_task.c_time':['>',moment().add(-1, 'minutes').format('YYYY-MM-DD HH:mm:ss')]})
      .field('queue.*,meeting_room.roomShort').order('queue.createTime ASC').select();
    let calling = [];
    // call 去重
    call = JSON.parse(JSON.stringify(call));
    function unique(arr) {
      var array = [];
      for (var i = 0; i < arr.length; i++) {
        let aStr = JSON.stringify(array)
        if (aStr.indexOf(arr[i].matterID) === -1) {
          array.push(arr[i])
        }else {
          for (var j = 0; j < array.length; j++){
            if (array[j].matterID === arr[i].matterID){
              array[j] = arr[i];
              break;
            }
          }
        }
      }
      return array
    }
    let newCall = unique(call);
    // 去重结束
    newCall.forEach(function(item) {
      let str = '请'+ item.roomCode + item.roomCodeNum + '到' + item.roomShort + '接谈室进行接谈';
      calling.push(str)
    });
    return this.success({'room':room,'calling':calling})
  }
};
