const Base = require('./../base.js');
const uuid = require('node-uuid');
const moment = require('moment');
const path = require('path');
const util = require('./../../handle/util.js');
const upload = require('./../../handle/uploadFile');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  // 大会版事项新增或者修改
  async addAction() {
    // 先有活动
    const data = this.post();
    let userInfo = await this.getUserInfo(data.userId);
    // 判断是新增还是修改matter
    if (typeof data.id === 'undefined' || data.id === '') {
      // 新增matter
      data['id'] =  uuid.v1();
    }else {
      // 修改matter
      // 删除标签统计表中数据
      await this.model('label_count').where({'matterID': data.id}).delete();
    }
    let label = []; // 要插入的标签列表
    // data.hotspot = typeof data.hotspot === 'object' ? data.hotspot : JSON.parse(data.hotspot);
    data.hotspot = Array.isArray(data.hotspot)? JSON.stringify(data.hotspot) : data.hotspot;
    data.hotspot.forEach(function(hotS) {
      label.push({
        "labelName":hotS.name,
        "labelID":hotS.id,
        "type":1,
        "matterID":data.id,
        "userId":data.userid,
        "orgID":userInfo.orgID,
        "orgName":userInfo.orgName,
      })
    });
    // data.personspot = typeof data.personspot === 'object' ? data.personspot : JSON.parse(data.personspot);
    data.personspot = Array.isArray(data.personspot)? JSON.stringify(data.personspot) : data.personspot;
    data.personspot.forEach(function(personS) {
      label.push({
        "labelName":personS.name,
        "labelID":personS.id,
        "type":2,
        "matterID":data.id,
        "userId":data.userid,
        "orgID":userInfo.orgID,
        "orgName":userInfo.orgName,
      })
    });
    data['activityID'] = data.activityID;
    data['contraband'] = data['contraband'] ?data['contraband'].join(',') : "";
    data['SKSFL'] = data['SKSFL'] ? data['SKSFL'].join(',') : "";
    data['url'] = data['url'] ? data['url'].join(',') : "";
    // data['hotspot'] = data['hotspot'] ? JSON.stringify(data['hotspot']) : ""; // 热点问题标签
    // data['personspot'] = data['personspot'] ? JSON.stringify(data['personspot']) : ""; // 个人标签
    data['contentClassify'] = data['contentClassify'].toString(); // 问题分类可能多选，多选的话是数组，所以转字符串，单选依旧是字符串
    data['contentClassifyID'] = data['contentClassifyID'].toString(); // 问题分类可能多选，多选的话是数组，所以转字符串，单选依旧是字符串
    data['createPerson'] = userInfo.name;
    data['createAccount'] = userInfo.user_name;
    data['isMeeting'] = 0;//是否大会版 0是1不是
    // 新增或者修改matter
    await this.model('matter').thenUpdate(data,{'id':data.id});
    // 再插入标签统计数据
    if (label.length > 0){
      await this.model('label_count').addMany(label);
    }
    let state = [];
    state.push({
      'matterID': data.id,
      'activityID': data.activityID,
      'state': 1,
      'stateName': '待提交登记审批',
      'nextState': 2,
      'nextStateName': '登记待审批/已提交登记审批',
      'departmentID': userInfo.orgID,
      'department': userInfo.orgName, // 机构
      'description': userInfo.description, // 地区
      'dictValue': userInfo.dictValue,
      'handlePerson': userInfo.name,
      'handlePersonID': userInfo.user_name,
    })
    // 在matter_state中插入新状态
    await this.model('matter_state').add(state);
    // 更新活动表中matterID
    await this.model('activity').where({'id':data.activityID}).update({'matterID': data.id});
    return this.json({
      'errno': 0,
      'errmsg': '',
      'data': {
        'matterID': data.id,
        'activityID': data.activityID // 因为活动不会在这里插入了，只有更新
      }
    });
  }
  // 大会版删除matter
  async deleteAction(){
    let data = this.post();
    // 先验证是否有这个事项
    let matter = await this.model('matter').setRelation(false).where({'id':data.id}).find()
    if (think.isEmpty(matter)){
      return this.fail();// 没有这个事项
    } else {
      // 删除matter
      await this.model('matter').where({'id':data.id}).delete();
      // 删除标签统计表中数据
      await this.model('label_count').where({'matterID': data.id}).delete();
      // 在matter_state中插入新状态
      await this.model('matter_state').add(state);
      // 更新活动表中matterID
      await this.model('activity').where({'id':matter.activityID}).update({'matterID': data.id});
      return this.success();
    }
  }
  async testAction(){
    // //创建路径
    // let filePath = path.join(think.ROOT_PATH, '/www/static', moment().format('YYYY年')+'/'+moment().format('M月'));
    // upload.mkdirsSync(filePath);// 创建文件夹（如果需要）
    // let url = encodeURI('https://sc.ftqq.com/SCU161530T448275af43de6f52c8af521b5b0c66ad603473e1cd617.send?text=掉线消息&desp=中文转换测试');
    // await httpRequest('get',url,{});
    // let back = await this.model('matter').where({'id':'01fb2100-fd8e-11ea-8207-15fdccc69a37'}).select();
    let MSG = require('./../../handle/msg');
    let util = require('./../../handle/util');
    let temp = require('./../../handle/template');
    // type 类型1短信2告知单
    // stage 信访阶段，1登记签收，2分类处理，4结案审核
    // 通过userId查询发送单位是否开通网上信访 0开通，1未开通
    // isRepresent  0发送给代表 1发送给信访人
    // isAccept  0受理，1不受理
    // handleModel  办理方式，1交办转送，2接谈存信存件

    let stage = 4;
    let p = this.post();
    let type = p.type;
    let data = {
      'userId':'025418a565a744c7a50c39899a73c897a',
      'handleModel':p.handleModel,
      'isAccept':p.isAccept,
      'isRepresent':p.isRepresent,
    }
    let back = await temp.getTellTemplate(type,stage,data);

    return this.success(back)
    // return this.success()
  }
};
