const Base = require('./../base.js');
const MSG = require('./../../handle/msg.js');
const moment = require('moment');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }

  // 按机构获取群发人员列表
  async getPersonListAction(){
    let data = this.post();
    let user = await this.model('sys_user').where({'del_flag':1,'dictValue':data.deptID}).select();
    let orgID = [];
    user.forEach(function(item) {
      orgID.push(item.orgID);
    });
    if (orgID.length === 0){
      return this.success([]);
    }
    let org = await this.model('sys_organization').where({'id':['IN',orgID]}).select();
    let back = [];
    org.forEach(function(i) {
      back.push({
        "orgID":i.id,
        "orgName":i.orgName,
        "person":[]
      })
    });
    for (let b of back){
      for (let u of user){
        if (u.orgID === b.orgID){
          b.person.push({
            'name':u.name,
            'phone':u.mobilePhone,
          })
        }
      }
    }
    return this.success(back);
  }

  // 大会版自定义发送短信
  async tellOfficerAction(){
    let data = this.post();
    // 传入 person []
    // 传入 title  "签名"
    // 传入 content "短信内容"
    // let content = "测试并发短信";
    let content = data.content + "【"+data.title+"】";
    for (let i = 0; i < data.person.length; i++) {
      // await MSG.msg(data.person[i].phone,content);
      // await httpRequest('post','https://192.9.200.55:8360/msg/msg/sendMsg',{"phone":data.person[i].phone,"content":content });//发送短信
      await httpRequest('post','https://172.28.50.118/msg/msg/sendMsg',{"phone":data.person[i].phone,"content":content });//发送短信
      // 插入发送记录
      let add = {
        'phone':data.person[i].phone,
        'name':data.person[i].name,
        'orgName':data.person[i].orgName,
        'orgID':data.person[i].orgID,
        'content':content,
        'title':data.title,
        'userId':data.userId,
      };
      await this.model('work_sms').add(add);
    }
    return this.success();
  }
  // 群发短信列表
  async smsListAction(){
    let data = this.post();
    let where = {
      'name':data.name === undefined || data.name === '' ? ['!=',null] :['LIKE',"%" + data.name + "%"],
      'content':data.content === undefined || data.content === '' ? ['!=',null] :['LIKE',"%" + data.content + "%"],
      'orgName':data.orgName === undefined || data.orgName === '' ? ['!=',null] :['LIKE',"%" + data.orgName + "%"],
      'phone':data.phone === undefined || data.phone === '' ? ['!=',null] :data.phone,
    };
    // 时间
    if ((!data.hasOwnProperty('startTime') && !data.hasOwnProperty('endTime')) || (data.startTime === '' && data.endTime === '')){
      where['time'] = ['!=', null] //全选
      // 默认当天
    } else if (data.startTime === ''){
      // 未设定开始时间
      where['time'] = ['between', '1900-01-01' + ',' + moment(data.endTime).add(1, 'day').format('YYYY-MM-DD')]
    } else if (data.endTime === ''){
      // 未设定结束时间
      where['time'] = ['between', moment(data.startTime).format('YYYY-MM-DD') + ',' + '2099-01-01']
    } else {
      where['time'] = ['between', moment(data.startTime).format('YYYY-MM-DD') + ',' + moment(data.endTime).add(1, 'day').format('YYYY-MM-DD')]
    }
    const sms = await this.model('work_sms').where(where).page(data.page, data.limit).order('time DESC').countSelect();
    return this.success(sms)
  }

  async dhTestAction(){
    let list = [
      // {'name':"马建军",'phone':"18056008686"},
      // {'name':"杨治松",'phone':"18056008731"},
      // {'name':"曹祝萍",'phone':"18949698219"},
      // {'name':"汪后方",'phone':"18055199381"},
      // {'name':"张爱华",'phone':"13956927522"},
      // {'name':"谭亚军",'phone':"18356765153"},
      // {'name':"刘志峰",'phone':"18056002233"},
      // {'name':"刘国庆",'phone':"15055157388"},
      // {'name':"张碧辉",'phone':"18297913922"},
      // {'name':"秦仲华",'phone':"13905519195"},
      // {'name':"吴三明",'phone':"13705511201"},
      // {'name':"徐晓兵",'phone':"13705698566"},
      // {'name':"江旭斌",'phone':"15867224472"}
      // {'name':"樊璐华",'phone':"15638932672"}
    ];
    for (let i = 0; i < list.length; i++) {
      // await MSG.msg(data.person[i].phone,content);
      // let content = '领导您好！您的大会信息管理系统（http://192.9.200.52:88/ahrd/index.html）及通知小工具,登录账号为中文:' +
      let content = '领导您好！您的大会信息管理系统（http://172.28.50.118:88/ahrd/index.html）及通知小工具,登录账号为中文:' +
        list[i].name + "，密码为6位数字:"+list[i].phone.substr(-6,6)+"。【信访办】";
      await httpRequest('post','https://172.28.50.118/msg/msg/sendMsg',{"phone":list[i].phone,"content":content });//发送短信
    }
  }
};
