const Base = require('./../base.js');
module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  // 获取全国所有省，以及安徽省下面所有市
  async getDeptAction(){
    let dept;
    let where = {
      'type':2
    };
    if (this.get().isOut === '1') { // 域外
      where['id'] = ['!=',2];// 排除安徽
      dept = await this.model('sys_dept').where(where).select();
      return this.success(dept)
    }else {
      where['id'] = 2; // 只有安徽
      dept = await this.model('sys_dept').where(where).select();
      let city = await this.model('sys_dept').where({'type':3,'parentID':2}).select();
      dept = JSON.parse(JSON.stringify(dept));
      city = JSON.parse(JSON.stringify(city));
      dept[0]['children'] = city;
      return this.success(dept)
    }
  }
  // 大会版获取去向单位 直接获取省级去向单位
  async getFinalDisposalAction(){
    let where = {};
    where['sys_dept.id'] = this.get().deptID; // 地区id
    if (typeof this.get().deptID === 'undefined'){
      return this.success([]);
    }
    if (this.get().deptID === '2'){
      // 如果是安徽，则是省内职能机构
      where['sys_organization.isRenDa'] = ["!=",1]
    } else {
      // 不是安徽，市级人大
      where['sys_organization.agent'] = 1
    }
    const org = await this.model('sys_organization').join('sys_dept on sys_dept.id = sys_organization.deptID')
      .where(where).field('sys_organization.id,sys_organization.orgName').select();
    return this.success(org)
  }
}
