const Base = require('./../base.js');
const moment = require('moment');
const uuid = require('node-uuid');
const util = require('./../../handle/util.js');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  //大会版获取省人大工作人员
  async getOrgUserAction(){
    const account = await this.model('sys_user').where({del_flag: 1,isLead:0,orgID:40})
      .field('name,sys_user.user_id,orgID').select();
    return this.success(account)
  }
  // 同件信访事项人员名单
  async getMatterPersonAction(){
    let data = this.post();
    let matter = await this.model('matter').where({'id':data.matterID}).find();
    if (think.isEmpty(matter)){
      return this.success()
    }
    let contentClassifyAll = ""; // 问题分类全称
    let cc = matter.contentClassifyID.split(',');// 问题分类
    let ccaID = matter.contentClassifyID;
    if (cc[0].substr(0,3) === '003') {// 如果是纪检监察类多选
      // 判断是否有contentClassifyMain，如果没有，取第一个
      if (matter.contentClassifyMainID === null || matter.contentClassifyMainID === ''){
        ccaID = cc[0];
      }
    }
    async function L1(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':ccaID.substr(0,3)}).find();
      return think.isEmpty(back) ? "" : back.description;
    }
    async function L2(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':ccaID.substr(0,6)}).find();
      return think.isEmpty(back) ? "" : back.description
    }
    async function L3(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':ccaID.substr(0,9)}).find();
      return think.isEmpty(back) ? "" : back.description
    }
    async function L4(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':ccaID.substr(0,12)}).find();
      return think.isEmpty(back) ? "" : back.description
    }
    async function L5(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':ccaID.substr(0,15)}).find();
      return think.isEmpty(back) ? "" : back.description
    }
    let all = await Promise.all([L1(),L2(),L3(),L4(),L5()]);
    contentClassifyAll = all[0]+'-'+all[1]+'-'+all[2]+'-'+all[3]+'-'+all[4];
    contentClassifyAll = contentClassifyAll.substr(0,contentClassifyAll.lastIndexOf('-'));
    let personList = await this.model('person').join('person_activity on person_activity.personID = person.id')
      .where({'person_activity.activityID':matter.activityID}).field('person.*').select();
    let back = {
      'name':matter.activity.person.name,//首登记人
      'createTime':moment(matter.createTime).format('YYYY年M月D日'),//登记日期
      'registerPlace':matter.activity.registerPlace,//登记地点
      'xfNature':matter.activity.xfType,//信访性质 取值取错了
      'xfName':matter.xfName,//事项名称
      'objectName':matter.activity.person.person_activity.objectName,//反映群体名称
      'xfNumber':matter.activity.xfNumber,//信访人数
      'contentClassifyAll':contentClassifyAll,//问题分类
      'personList':[
        {
          'name':matter.activity.person.name,//首登记人
          'IDType':matter.activity.person.IDType,//证件类型
          'IDNumber':matter.activity.person.IDNumber,//证件号码
          'mobilePhone':matter.activity.person.mobilePhone,//手机
          'addressRegion':matter.activity.person.addressRegion,//现住地址所属地区
          'address':matter.activity.person.address,//现住地址
          'isMain':matter.activity.xfTypeID === '001002' ? 1 : 0,
        }
      ]
    };
    personList.forEach(function(item) {
      if (item.id !== matter.activity.person.id){
        back.personList.push({
          'name':item.name,
          'IDType':item.IDType,//证件类型
          'IDNumber':item.IDNumber,//证件号码
          'mobilePhone':item.mobilePhone,//手机
          'addressRegion':item.addressRegion,//现住地址所属地区
          'address':item.address,//现住地址
          'isMain':0
        })
      }
    });
    return this.success(back)
  }

  // 按问题属地统计信访人
  async getPersonHappenRegionAction(){
    let data = this.post();
    let startTime = moment().format('YYYY-MM-DD');
    let endTime = moment().add(1,'day').format('YYYY-MM-DD');
    // let startTime = moment('2022-07-05').format('YYYY-MM-DD');
    // let endTime = moment('2022-07-08').add(1,'day').format('YYYY-MM-DD');
    if (typeof data.startTime !== 'undefined' && data.startTime !== ''){
      startTime = moment(data.startTime).format('YYYY-MM-DD');
    }
    if (typeof data.endTime !== 'undefined' && data.endTime !== ''){
      endTime = moment(data.endTime).add(1,'day').format('YYYY-MM-DD');
    }
    let back = [];
    let screenWhere = {'a.createTime':['BETWEEN', startTime, endTime],'a.isMeeting':0};
    if (data.hasOwnProperty('registerTypeID') && Array.isArray(data.registerTypeID) && data.registerTypeID.length > 0) {
      screenWhere['a.registerTypeID'] = ['IN',data.registerTypeID];// 信访形式
    }
    let screen = await this.model('person_activity').alias('pa').join('activity as a on a.id = pa.activityID')
      .join('person as p on p.id = pa.personID').where(screenWhere)
      .field('a.registerPlace,a.createTime as jdTime,a.activityNum,a.id as activityID,p.*').select();
    let domicile = await this.model('dictionary').where({'dictID':'DQ','flag':1}).select();
    let happenRegion = await this.model('dictionary').where({'dictID':'AB','flag':1}).select();
    function findOne(list,key,length) {
      if (key.length !== length){
        return ""
      } else {
        for (let l of list){
          if (l.dictValue === key){
            return l.description;
          }
        }
      }
    }
    for (let s of screen){
      let oldHappen = [];
      let matter = await this.model('matter').where({'activityID':s.activityID}).select();
      matter.forEach(function(item) {
        oldHappen.push(item.happenRegionID.substr(0,6));
      });
      let newHappen = [...new Set(oldHappen)];// 去重
      if (oldHappen.length === newHappen.length){
        // 没有重复问题属地（到市一级） 每条都不一样或者只有一条
        for (let o of oldHappen){
          for (let m of matter){
            if (m.happenRegionID.substr(0,6) === o){
              back.push({
                'createTime':s.jdTime,// 登记时间
                'registerPlace':s.registerPlace,// 登记地点
                'activityNum':s.activityNum,// 登记地点
                'mainPersonName':m.activity.person.name,// 首登记人姓名
                'name':s.name,// 登记人姓名
                'domicileProvince':findOne(domicile,s.domicileID.substr(0,3),3),// 户口 省
                'domicileCity':findOne(domicile,s.domicileID.substr(0,6),6),// 户口 市
                'domicileCounty':findOne(domicile,s.domicileID.substr(0,9),9),// 户口 县
                'IDType':s.IDType,// 证件类型
                'IDNumber':s.IDNumber,// 证件号码
                'addressRegion':s.addressRegion,// 现住址地区
                'address':s.address,// 现住址详细地址
                'mobilePhone':s.mobilePhone,// 手机
                'matterNum':m.matterNum,// 涉及事项编号
                'happenRegionProvince':findOne(happenRegion,m.happenRegionID.substr(0,3),3),// 问题属地 省
                'happenRegionCity':findOne(happenRegion,m.happenRegionID.substr(0,6),6),// 问题属地 市
                'happenRegionCounty':findOne(happenRegion,m.happenRegionID.substr(0,9),9),// 问题属地 县
              })
            }
          }
        }
      } else {
        // 有重复问题属地（到市一级）一个活动有不少于两个事项且至少有两个事项属于一个问题属地
        for (let n of newHappen){
          let items = {
            'createTime':s.jdTime,// 登记时间
            'registerPlace':s.registerPlace,// 登记地点
            'activityNum':s.activityNum,// 登记地点
            'mainPersonName':matter[0].activity.person.name,// 首登记人姓名
            'name':s.name,// 登记人姓名
            'domicileProvince':findOne(domicile,s.domicileID.substr(0,3),3),// 户口 省
            'domicileCity':findOne(domicile,s.domicileID.substr(0,6),6),// 户口 市
            'domicileCounty':findOne(domicile,s.domicileID.substr(0,9),9),// 户口 县
            'IDType':s.IDType,// 证件类型
            'IDNumber':s.IDNumber,// 证件号码
            'addressRegion':s.addressRegion,// 现住址地区
            'address':s.address,// 现住址详细地址
            'mobilePhone':s.mobilePhone,// 手机
            'matterNum':'',// 涉及事项编号
            'happenRegionProvince':'',// 问题属地 省
            'happenRegionCity':'',// 问题属地 市
            'happenRegionCounty':'',// 问题属地 县
          };
          for (let m of matter){
            if (m.happenRegionID.substr(0,6) === n){
              items.mainPersonName = m.activity.person.name;
              items.matterNum = (items.matterNum === ''? m.matterNum : items.matterNum+','+m.matterNum);
              items.happenRegionProvince = (items.happenRegionProvince === ''? findOne(happenRegion,m.happenRegionID.substr(0,3),3) : items.happenRegionProvince);
              items.happenRegionCity = (items.happenRegionCity === ''? findOne(happenRegion,m.happenRegionID.substr(0,6),6) : items.happenRegionCity);
              items.happenRegionCounty = (items.happenRegionCounty === ''? findOne(happenRegion,m.happenRegionID.substr(0,9),9) : items.happenRegionCounty);
            }
          }
          back.push(items);
        }
      }
    }
    return this.success(back);
  }

  // 信访总量统计
  async getActivityAction(){
    let data = this.post();
    let userInfo = await this.getUserInfo(data.userId);
    let startTime = moment('2022-01-01').format('YYYY-MM-DD');
    let endTime = moment('2099-12-31').add(1,'day').format('YYYY-MM-DD');
    if (typeof data.startTime !== 'undefined' && data.startTime !== ''){
      startTime = moment(data.startTime).format('YYYY-MM-DD HH:mm:ss');
    }
    if (typeof data.endTime !== 'undefined' && data.endTime !== ''){
      endTime = moment(data.endTime).format('YYYY-MM-DD HH:mm:ss');
    }
    let session = await this.model('meeting_session').where({'id':userInfo.meetingID}).find();
    if (!think.isEmpty(session)) {
      startTime = moment(session.startTime).format('YYYY-MM-DD');
      endTime = moment(session.endTime).add(1,'day').format('YYYY-MM-DD');
    }
    let back = [];
    // let activityWhere = {'createTime':['BETWEEN', startTime, endTime],'isMeeting':0};
    let activityWhere = {'isMeeting':0,'mainPerson':['!=',null],'createTime':['BETWEEN', startTime, endTime]};
    if (data.hasOwnProperty('registerTypeID') && Array.isArray(data.registerTypeID) && data.registerTypeID.length > 0) {
      activityWhere['registerTypeID'] = ['IN',data.registerTypeID];// 信访形式
    }
    let activity = await this.model('activity').where(activityWhere).order('createTime').select();
    let domicile = await this.model('dictionary').where({'dictID':'DQ','flag':1}).select();
    let happenRegion = await this.model('dictionary').where({'dictID':'AB','flag':1}).select();
    let ycPlace = await this.model('dictionary').where({'dictID':'YZ','flag':1,'dictValue':['LIKE','001002%']}).select();
    let ycAction = await this.model('dictionary').where({'dictID':'YZ','flag':1,'dictValue':['LIKE','001003%']}).select();
    let SKSFL = await this.model('dictionary').where({'dictID':'SK','flag':1}).select();
    let contentClassify = await this.model('dictionary').where({'dictID':'FYN','flag':1}).select();
    function findOne(list,key,length) {
      if (key.length !== length){
        return ""
      } else {
        for (let l of list){
          if (l.dictValue === key){
            return l.description;
          }
        }
      }
    }
    function findMany(list,key) {
      if (key === null){
        return ""
      }
      let keys = key.split(',');
      let back = [];
      for (let k of keys){
        for (let l of list){
          if (l.dictValue === k){
            back.push(l.description);
            break;
          }
        }
      }
      return back.toString()
    }
    function yc(ycPlace,ycAction,key) {
      let place = [];
      let action = [];
      if (key === null){
        return {'place':place,'action':action}
      }
      let list = key.split(',');
      for (let l of list){
        if (l.substr(0,6) === '001002'){
          for (let p of ycPlace){
            if (p.dictValue === l){
              place.push(p.description);
            }
          }
        }
        if (l.substr(0,6) === '001003'){
          for (let a of ycAction){
            if (a.dictValue === l){
              action.push(a.description);
            }
          }
        }
      }
      return {'place':place,'action':action}
    }
    for (let a of activity){
      // 接谈室叫号id，表queue
      // let sql = await this.model('queue').order('createTime desc').limit(1).buildSelectSql();
      // let matter = await this.model('matter').setRelation(false).where({'matter.activityID':a.id}).select();
      let matter;
      if(userInfo.isRenDa !== 1){
        //非人大单位，即为职能单位，仅查询本单位接谈情况
        matter = await this.model('matter').setRelation(false).join('talking_handle as th on th.matterID = matter.id')
          .where({'matter.activityID':a.id,'th.roomOrgID':userInfo.orgID}).select();
      }else {
        matter = await this.model('matter').setRelation(false).where({'matter.activityID':a.id}).select();
      }
      if (think.isEmpty(matter)){
        continue;
      }
        // .join({table: sql,as: 'q', join: 'left', on: ['id', 'matterID']}).where({'matter.activityID':a.id})
        // .field('matter.*,q.contentClassifyAll,q.roomOrgName').select();
      let matterList = [];
      for (let item of matter){
        let queue = await this.model('queue').where({'matterID':item.id}).order('createTime desc').find();
        let contentClassifyAll = ((item.contentClassifyMainID === null || item.contentClassifyMainID === '') ? item.contentClassifyID : item.contentClassifyMainID)
        matterList.push({
          'matterNum':item.matterNum,//信访事项编号
          'happenRegionProvince':findOne(happenRegion,item.happenRegionID.substr(0,3),3),// 问题属地 省
          'happenRegionCity':findOne(happenRegion,item.happenRegionID.substr(0,6),6),// 问题属地 市
          'happenRegionCounty':findOne(happenRegion,item.happenRegionID.substr(0,9),9),// 问题属地 县
          'belongs':item.belongsID.substr(0,3) === '001'?'人大':item.belongs,// 问题所属系统
          'isSKSFL':item.isSKSFL === 1 ? '是': '否',// 是否三跨三分离
          'SKSFL':item.isSKSFL === 1 ? findMany(SKSFL,item.SKSFL) : '',// 三跨三分离情况
          // 'contentClassify1':typeof queue.contentClassifyAll !=='undefined' ? queue.contentClassifyAll.split('-')[0] : '',// 反映问题分类1级
          // 'contentClassify2':typeof queue.contentClassifyAll !=='undefined' ? queue.contentClassifyAll.split('-')[1] : '',// 反映问题分类2级
          // 'contentClassify3':typeof queue.contentClassifyAll !=='undefined' ? queue.contentClassifyAll.split('-')[2] : '',// 反映问题分类3级
          // 'contentClassify4':typeof queue.contentClassifyAll !=='undefined' ? queue.contentClassifyAll.split('-')[3] : '',// 反映问题分类4级
          // 'contentClassify5':typeof queue.contentClassifyAll !=='undefined' ? queue.contentClassifyAll.split('-')[4] : '',// 反映问题分类5级
          'contentClassify1':findOne(contentClassify,contentClassifyAll.substr(0,3),3),// 反映问题分类1级
          'contentClassify2':findOne(contentClassify,contentClassifyAll.substr(0,6),6),// 反映问题分类2级
          'contentClassify3':findOne(contentClassify,contentClassifyAll.substr(0,9),9),// 反映问题分类3级
          'contentClassify4':findOne(contentClassify,contentClassifyAll.substr(0,12),12),// 反映问题分类4级
          'contentClassify5':findOne(contentClassify,contentClassifyAll.substr(0,15),15),// 反映问题分类5级
          'abstract':item.abstract,// 信访摘要
          'appealContent':item.appealContent,// 诉求
          'identityType':item.identityType,// 被反映人身份类型
          'postType':item.postType,// 意见建议对象职务类型
          'talkingOrg':queue.roomOrgName,// 接谈单位
          'handleModel':item.handleModel === '转交' ? "转送" : item.handleModel,// 办理方式
          'finalDisposal':item.finalDisposal,// 去向单位
          'visit':item.visit,// 初重情况
          'createPerson':item.createPerson,// 登记人
        })
      }
      let abnorma = yc(ycPlace,ycAction,a.abnormalID);
      back.push({
        'djTime':a.createTime,// 登记时间
        'registerPlace':a.registerPlace,// 登记地点
        'activityNum':a.activityNum,// 活动编号
        'xfNumber':a.xfNumber,// 信访人数
        'isAbnormal':a.isAbnormal === 0 ? '否':'是',// 是否异常
        'abnormalPlace':a.isAbnormal === 0 ? '':abnorma.place.toString(),// 异常场所
        'abnormalAction':a.isAbnormal === 0 ? '':abnorma.action.toString(),// 异常行为
        'mainPerson':a.person.name,// 首登记人
        'domicileProvince':findOne(domicile,a.person.domicileID.substr(0,3),3),// 户口 省
        'domicileCity':findOne(domicile,a.person.domicileID.substr(0,6),6),// 户口 市
        'domicileCounty':findOne(domicile,a.person.domicileID.substr(0,9),9),// 户口 县
        'IDType':a.person.IDType,// 证件类型
        'IDNumber':a.person.IDNumber,// 证件号码
        'addressRegion':a.person.addressRegion,// 现住址地区
        'address':a.person.address,// 现住址详细地址
        'mobilePhone':a.person.mobilePhone,// 手机
        'matterList':matterList
      })
    }
    return this.success(back)
  }
  // 劝返移交单
  async getPersuadeAction(){
    let data = this.post();
    let back = await this.model('talking_handle').where({'matterID':data.matterID}).find();
    if (think.isEmpty(back)){
      return this.success()
    }
    let person = await this.model('person').join('person_activity as pa on pa.personID = person.id')
      .join('matter on matter.activityID = pa.activityID').where({'matter.id':data.matterID}).field('person.name').select();
    back = JSON.parse(JSON.stringify(back));
    back['persuadePerson'] = [];
    back['printTime'] = moment().format('YYYY年M月D日 HH:mm:ss');
    person.forEach(function(item) {
      back.persuadePerson.push(item.name);
    });
    return this.success(back)
  }

  //大会期间数据统计
  async getWordAction(){
    let data = this.post();
    let time = moment().format('YYYY-MM-DD');//当天
    let startTime = moment(time).add(-8,'hour').format('YYYY-MM-DD HH:mm:ss');// 默认前一天16时开始
    let endTime = moment(time).add(16,'hour').format('YYYY-MM-DD HH:mm:ss');// 默认当天16时结束
    if (typeof data.startTime !== 'undefined' && data.startTime !== ''){
      startTime = moment(data.startTime).format('YYYY-MM-DD HH:mm:ss');
    }
    if (typeof data.endTime !== 'undefined' && data.endTime !== ''){
      endTime = moment(data.endTime).format('YYYY-MM-DD HH:mm:ss');
    }
    let activityWhere = {
      'createTime':['BETWEEN',startTime,endTime],
      'isMeeting':0,
      'registerTypeID':'001',// 仅来访
    };
    if (data.hasOwnProperty('registerPlaceID') && data.registerPlaceID.length > 0){
      activityWhere['registerPlaceID'] = ['IN',data.registerPlaceID];
    }
    let activity = await this.model('activity').where(activityWhere).select();
    let personSum = await this.model('activity').sum('xfNumber');// 信访总人数
    let matterSum = 0;// 第一段信访事项总数
    let matterDP = 0;// 第一段信访事项多批次反映多个信访事项
    let matterDR = 0;// 第一段信访事项多人次反映多个信访事项
    let jtSum = 0; // 第一段集体访批次
    let jtPersonSum = 0; // 第一段集体访人数
    let region = [];// 第二段数据源（事项）
    // 第二段
    let hefeiP = 0;//合肥
    let hefeiR = 0;//合肥
    let huaibeiP = 0;//淮北
    let huaibeiR = 0;//淮北
    let bozhouP = 0;//亳州
    let bozhouR = 0;//亳州
    let suzhouP = 0;//宿州
    let suzhouR = 0;//宿州
    let bengbuP = 0;//蚌埠
    let bengbuR = 0;//蚌埠
    let fuyangP = 0;//阜阳
    let fuyangR = 0;//阜阳
    let huainanP = 0;//淮南
    let huainanR = 0;//淮南
    let chuzhouP = 0;//滁州
    let chuzhouR = 0;//滁州
    let luanP = 0;//六安
    let luanR = 0;//六安
    let maanshanP = 0;//马鞍山
    let maanshanR = 0;//马鞍山
    let wuhuP = 0;//芜湖
    let wuhuR = 0;//芜湖
    let xuanchengP = 0;//宣城
    let xuanchengR = 0;//宣城
    let tonglingP = 0;//铜陵
    let tonglingR = 0;//铜陵
    let chizhouP = 0;//池州
    let chizhouR = 0;//池州
    let anqingP = 0;//安庆
    let anqingR = 0;//安庆
    let huangshanP = 0;//黄山
    let huangshanR = 0;//黄山
    let guangdeP = 0;//广德
    let guangdeR = 0;//广德
    let susongP = 0;//宿松
    let susongR = 0;//宿松
    let shengzhiP = 0;//省直
    let shengzhiR = 0;//省直
    let shengwaiP = 0;//省外
    let shengwaiR = 0;//省外
    //遍历问题属地
    function findRegion(key,personNum) {
      switch (key) {
        case '001000':// 省直
          shengzhiP = shengzhiP + 1;
          shengzhiR = shengzhiR + personNum;
          break;
        case '001001':// 合肥市
          hefeiP = hefeiP + 1;
          hefeiR = hefeiR + personNum;
          break;
        case '001002':// 淮北市
          huaibeiP = huaibeiP + 1;
          huaibeiR = huaibeiR + personNum;
          break;
        case '001003':// 亳州市
          bozhouP = bozhouP + 1;
          bozhouR = bozhouR + personNum;
          break;
        case '001004':// 宿州市
          suzhouP = suzhouP + 1;
          suzhouR = suzhouR + personNum;
          break;
        case '001005':// 蚌埠市
          bengbuP = bengbuP + 1;
          bengbuR = bengbuR + personNum;
          break;
        case '001006':// 阜阳市
          fuyangP = fuyangP + 1;
          fuyangR = fuyangR + personNum;
          break;
        case '001007':// 淮南市
          huainanP = huainanP + 1;
          huainanR = huainanR + personNum;
          break;
        case '001008':// 滁州市
          chuzhouP = chuzhouP + 1;
          chuzhouR = chuzhouR + personNum;
          break;
        case '001009':// 六安市
          luanP = luanP + 1;
          luanR = luanR + personNum;
          break;
        case '001010':// 马鞍山市
          maanshanP = maanshanP + 1;
          maanshanR = maanshanR + personNum;
          break;
        case '001011':// 芜湖市
          wuhuP = wuhuP + 1;
          wuhuR = wuhuR + personNum;
          break;
        case '001012':// 宣城市
          xuanchengP = xuanchengP + 1;
          xuanchengR = xuanchengR + personNum;
          break;
        case '001013':// 铜陵市
          tonglingP = tonglingP + 1;
          tonglingR = tonglingR + personNum;
          break;
        case '001014':// 池州市
          chuzhouP = chizhouP + 1;
          chizhouR = chizhouR + personNum;
          break;
        case '001015':// 安庆市
          anqingP = anqingP + 1;
          anqingR = anqingR + personNum;
          break;
        case '001016':// 黄山市
          huangshanP = huangshanP + 1;
          huangshanR = huangshanR + personNum;
          break;
        case '001017':// 广德市
          guangdeP = guangdeP + 1;
          guangdeR = guangdeR + personNum;
          break;
        case '001018':// 宿松县
          susongP = susongP + 1;
          susongR = susongR + personNum;
          break;
        default : // 外省
          shengwaiP = shengwaiP + 1;
          shengwaiR = shengwaiR + personNum;
      }
    }
    console.log(activity.length)
    for (let a of activity) {
      if (a.xfTypeID!== '001001'){ // 非个人访
        jtSum = jtSum +1;
        jtPersonSum = jtPersonSum + a.xfNumber;
      }
      let m = await this.model('matter').setRelation(false).where({'activityID':a.id}).select();
      if (!think.isEmpty(m)){
        matterSum = matterSum + m.length;
        if (m.length > 1){
          matterDP = matterDP + 1;
          matterDR = matterDR + a.xfNumber;
          let oldHappen = [];
          m.forEach(function(item) {
            oldHappen.push(item.happenRegionID.substr(0,6));
          });
          let newHappen = [...new Set(oldHappen)];// 去重, 问题属地
          for (let h of newHappen){
            findRegion(h,a.xfNumber);
          }
        }else {
          findRegion(m[0].happenRegionID.substr(0,6),a.xfNumber);
        }
      }
    }
    // 第一段
    let str1 = startTime + '至' + endTime + ',省十三届人大四次会议秘书处信访组接待群众来访' + activity.length + '批' +
      personSum + '人次,来访共反映信访事项' + matterSum + '个' + (matterDP === 0 ? '' : '（'+matterDP+'批'+matterDR+'人次群众反映了多个信访事项）')
      + (jtSum === 0 ? '。' : '其中：集体访'+jtSum+'批'+ jtPersonSum +'人次。');
    console.log(str1)
    let str2 = (hefeiP === 0 ? '' : '合肥市' + hefeiP + '批' + hefeiR + '人次。') +
      (huaibeiP === 0 ? '' : '淮北市' + huaibeiP + '批' + huaibeiR +'人次。') +
      (bozhouP === 0 ? '' : '亳州市' + bozhouP + '批' + bozhouR +'人次。') +
      (suzhouP === 0 ? '' : '宿州市' + suzhouP + '批' + suzhouR +'人次。') +
      (bengbuP === 0 ? '' : '蚌埠市' + bengbuP + '批' + bengbuR +'人次。') +
      (fuyangP === 0 ? '' : '阜阳市' + fuyangP + '批' + fuyangR +'人次。') +
      (huainanP === 0 ? '' : '淮南市' + huainanP + '批' + huainanR +'人次。') +
      (chuzhouP === 0 ? '' : '滁州市' + chuzhouP + '批' + chuzhouR +'人次。') +
      (luanP === 0 ? '' : '六安市' + luanP + '批' + luanR +'人次。') +
      (maanshanP === 0 ? '' : '马鞍山市' + maanshanP + '批' + maanshanR +'人次。') +
      (wuhuP === 0 ? '' : '芜湖市' + wuhuP + '批' + wuhuR +'人次。') +
      (xuanchengP === 0 ? '' : '宣城市' + xuanchengP + '批' + xuanchengR +'人次。') +
      (tonglingP === 0 ? '' : '铜陵市' + tonglingP + '批' + tonglingR +'人次。') +
      (chizhouP === 0 ? '' : '池州市' + chizhouP + '批' + chizhouR +'人次。') +
      (anqingP === 0 ? '' : '安庆市' + anqingP + '批' + anqingR +'人次。') +
      (huangshanP === 0 ? '' : '黄山市' + huangshanP + '批' + huangshanR +'人次。') +
      (guangdeP === 0 ? '' : '广德市' + guangdeP + '批' + guangdeR +'人次。') +
      (susongP === 0 ? '' : '宿松县' + susongP + '批' + susongR +'人次。') +
      (shengzhiP === 0 ? '' : '省直' + shengzhiP + '批' + shengzhiR +'人次。') +
      (shengwaiP === 0 ? '' : '省外' + shengwaiP + '批' + shengwaiR +'人次。')
    console.log(str2)
    let where3 = {
      'createTime':['BETWEEN',startTime,endTime],
      'isMeeting':0,
      'registerTypeID':'001',// 仅来访
      'isAbnormal':1//异常访
    };
    let activity3 = await this.model('activity').where(where3).select();
    let ycP = 0;//异常总批
    let ycJP = 0;//异常总集体批
    let ycR = 0;//异常总人
    let ycJR = 0;//异常总集体人
    let zxP = 0;//主席团驻地批
    let zxJP = 0;//主席团驻地集体批
    let zxR = 0;//主席团驻地人
    let zxJR = 0;//主席团驻地集体人
    let dbP = 0;//代表团驻地批
    let dbJP = 0;//代表团驻地集体批
    let dbR = 0;//代表团驻地人
    let dbJR = 0;//代表团驻地集体人
    let tyP = 0;//统一接待点批
    let tyJP = 0;//统一接待点集体批
    let tyR = 0;//统一接待点人
    let tyJR = 0;//统一接待点集体人
    let jdP = 0;//接待中心窗口批
    let jdJP = 0;//接待中心窗口集体批
    let jdR = 0;//接待中心窗口人
    let jdJR = 0;//接待中心窗口集体人
    let jgP = 0;//机关批
    let jgJP = 0;//机关集体批
    let jgR = 0;//机关人
    let jgJR = 0;//机关集体人
    for (let a3 of activity3){
      ycP = ycP + 1;
      ycR = ycR + a3.xfNumber;
      switch (a3.registerPlaceID) {
        case 1://统一接待点
          tyP = tyP + 1;
          tyR = tyR + a3.xfNumber;
          if (a3.xfTypeID !== '001001'){//集体访
            tyJP =tyJP + 1;
            tyJR =tyJR + a3.xfNumber;
          }
        case 2://代表团驻地
          dbP = dbP + 1;
          dbR = dbR + a3.xfNumber;
          if (a3.xfTypeID !== '001001'){//集体访
            dbJP =dbJP + 1;
            dbJR =dbJR + a3.xfNumber;
          }
        case 3://主席团驻地
          zxP = zxP + 1;
          zxR = zxR + a3.xfNumber;
          if (a3.xfTypeID !== '001001'){//集体访
            zxJP =zxJP + 1;
            zxJR =zxJR + a3.xfNumber;
          }
        case 4://机关
          jgP = jgP + 1;
          jgR = jgR + a3.xfNumber;
          if (a3.xfTypeID !== '001001'){//集体访
            jgJP =jgJP + 1;
            jgJR =jgJR + a3.xfNumber;
          }
        case 5://接待中心窗口
          jdP = jdP + 1;
          jdR = jdR + a3.xfNumber;
          if (a3.xfTypeID !== '001001'){//集体访
            jdJP =jdJP + 1;
            jdJR =jdJR + a3.xfNumber;
          }
      }
    }
    let ty = tyP === 0 ? '':'统一接待点'+tyP+'批'+tyR+'人次'+(tyJR === 0 ? '':'（其中集体访'+tyJP+'批'+tyJR+'人次）、');
    let db = dbP === 0 ? '':'代表团驻地'+dbP+'批'+dbR+'人次'+(dbJP === 0 ? '':'（其中集体访'+dbJP+'批'+dbJR+'人次）、');
    let zx = zxP === 0 ? '':'主席团驻地'+zxP+'批'+zxR+'人次'+(zxJP === 0 ? '':'（其中集体访'+zxJP+'批'+zxJR+'人次）、');
    let jg = jgP === 0 ? '':'机关'+jgP+'批'+jgR+'人次'+(jgJP === 0 ? '':'（其中集体访'+jgJP+'批'+jgJR+'人次）、');
    let jd = jdP === 0 ? '':'接待中心窗口'+jdP+'批'+jdR+'人次'+(jdJP === 0 ? '':'（其中集体访'+jdJP+'批'+jdJR+'人次）');
    let str3 = '来访中，异常信访'+ycP+'批'+ycR+'人次' + (ycJP === 0 ? '':'（其中集体访'+ycJP+'批'+ycJR+'人次）') +
      (ty===''&&db===''&&zx===''&&jg===''&&jd==='')?'':('分别为'+ty+db+zx+jg+jd);
    console.log(str3);
    // 第四段
    // 回流访
    // 第五段
    let sql5 = 'select visit ,COUNT(visit) AS sum from matter as m LEFT JOIN activity as a ON a.id = m.activityID' +
      ' WHERE a.registerTypeID = "001" AND m.isMeeting = 0 AND m.createTime BETWEEN "'+startTime+'" AND "'+ endTime +'" group by visit'
    let matter5 = await this.model('matter').query(sql5);
    let str5 = '来访反映的信访事项中，初次向人大系统反映的'+(matter5[0].visit === "初次反映" ? matter5[0].sum : matter5[1].sum)+'件，' +
      '重复反映的'+(matter5[0].visit === "重复反映" ? matter5[0].sum : matter5[1].sum)+'件。'
    console.log(str5)
  }
};
