const Base = require('./../base.js');
const moment = require('moment');

// winForm 消息推送相关
module.exports = class extends Base {
  /**
   * showdoc
   * @catalog 消息提醒
   * @title 消息提醒
   * @description 消息提醒接口
   * @method post
   * @url http://127.0.0.1:8360/meeting/prompt/getMsg
   * @param userId 必选 string userId
   * @return {"errno": 0, "errmsg":""，"data":{"businessID":34,"count":0}}
   */
  async getMsgAction(){
    let data = this.post();
    let user = [
      {'userId':'e326b5ecd5d648108728ed65631fa14f','type':1,'name':'张庆'},
      {'userId':'bc5e5aa8d8f7448f951541f08026fcfd','type':1,'name':'杨彤'},
      {'userId':'3e70e6d183284ace94b0ec2d5b32778f','type':1,'name':'许少春'},
      {'userId':'61c0543da82b46f0af346226da822197','type':2,'name':'王晓'}// 分类处理
    ];
    let businessID = [34];
    for (let u of user){
      if (data.userId === u.userId) {
        if (u.type === 1){
          // 大会领导
          businessID = [1,2]
        }
        if (u.type === 2){
          // 大会分类处理
          businessID = [36]
        }
        break;
      }
    }
    let back = {
      'businessID':'',
      'count':''
    };
    let where = {
      'businessID':['IN',businessID]
    };
    if (businessID[0] === 34){
      // 判断为接谈室工作工作人员
      let userInfo = await this.getUserInfo(data.userId);
      if (typeof userInfo.orgID === 'undefined'){
        return this.fail()
      }
      where['deptID_now'] = userInfo.orgID;
      where['c_time'] = ['>',moment().add(-30,'minute').format('YYYY-MM-DD HH:mm:ss')];
    }
    let count = await this.model('fw_task').where(where).count();
    back.businessID = businessID;
    back.count = count;
    return this.success(back);
  }
}
