// 执行成功后会在你的项目指定目录下生成一个mp3文件,使用播放器直接播放即可
// 注意：js文件必须是utf-8编码格式，其他格式文件会出现返回空语音的情况
const Base = require('./../base.js');
const xunfeiTTS = require('xf-tts-socket');
const {promisify} = require('util');
const tts = promisify(xunfeiTTS);
const path = require('path');
const moment = require('moment');

const app_id = '60012bb8';
const app_skey = '060d16d7a8fbd1cf12b8db3473fb22e3';
const app_akey = 'b258cac278b2aa54b4980c4c8e2f6c8a';

// const test_async_await_mp3 = async(app_id, app_skey, app_akey) => {
//   const auth = {app_id, app_skey, app_akey};
//   // business 支持所有语音参数，详见：
//   // https://www.xfyun.cn/doc/tts/online_tts/API.html#%E4%B8%9A%E5%8A%A1%E5%8F%82%E6%95%B0%E8%AF%B4%E6%98%8E-business
//   const business = {aue: 'lame', sfl: 1, vcn: 'xiaoyan', speed: 50, pitch: 50, volume: 100};
//   const text = '两块钱不算多，去不了香港去不了新加坡';
//   const file = path.resolve('./test_async_await_mp3.mp3');
//
//   try {
//     const res = await tts(auth, business, text, file);
//     console.log(res);
//   } catch (e) {
//     console.log('test exception', e);
//   }
// };

// test_async_await_mp3(app_id, app_skey, app_akey);
module.exports = class extends Base {
  /**
   * showdoc
   * @catalog 语音生成
   * @title 语音生成
   * @description 语音生成
   * @method post
   * @url http://127.0.0.1:8360/msg/audio/generate
   * @param phrase 需要生成的语句
   * @return {"errno": 0, "errmsg":"", "data": "/static/audio/1610693943.mp3"}
   */
  async generateAction() {
    const text = this.post().phrase;
    const auth = {app_id, app_skey, app_akey};
    // business 支持所有语音参数，详见：
    // https://www.xfyun.cn/doc/tts/online_tts/API.html#%E4%B8%9A%E5%8A%A1%E5%8F%82%E6%95%B0%E8%AF%B4%E6%98%8E-business
    const business = {aue: 'lame', sfl: 1, vcn: 'xiaoyan', speed: 50, pitch: 50, volume: 100};
    const filename = moment().format('X');
    const file = path.resolve('./www/static/audio/' + filename + '.mp3');

    try {
      const res = await tts(auth, business, text, file);
      this.success('/static/audio/' + filename + '.mp3');

    } catch (e) {
      this.fail();
    }
  }
};
