const Base = require('./../base.js');
const moment = require('moment');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  async waitTotalAction(){
    const data = this.post();
    const userInfo = await this.getUserInfo(data.userId);
    async function xfqb() {//信访签办
      //信访签办 21 22
      let where = {
        'fw.businessID': ['IN', [21, 22,15]],
        'fw.deptID_now': userInfo.orgID
      }
      return await think.model('matter').setRelation(false).alias('m').join('fw_task as fw on fw.id = m.taskid').where(where).count();
    }
    async function xfdj(){//信访登记
      // 审批退回24 + 未提交 + 网上未采纳
      let where1 = {
        'fw.businessID': ['IN', [24]],
        'fw.charger': data.userId
      }
      let where2 = {
        'ac.createAccount': userInfo.user_name,
        'ac.submit': 0
      }
      let spth = await think.model('matter').setRelation(false).alias('m').join('fw_task as fw on fw.id = m.taskid').where(where1).count();
      let wtj = await think.model('matter').setRelation(false).alias('m').join('activity as ac on ac.id = m.activityID').where(where2).count();
      let online = await think.model('online').where({"state":['IN',[0,1]],"djRegionID":userInfo.dictValue}).count();
      return spth + wtj + online
    }
    async function wsbz(){//文书编制
      //文书编制 3 5 7 25 28
      let where = {
        'fw.businessID': ['IN', [3,5,7,25,28]],
        'fw.charger': data.userId
      }
      return await think.model('matter').setRelation(false).alias('m').join('fw_task as fw on fw.id = m.taskid').where(where).count();
    }
    async function jbzs(){//交办转送
      //交办转送 6 9 27 30
      let where = {
        'fw.businessID': ['IN', [6,9,27,30]],
        'fw.charger': data.userId
      }
      return await think.model('matter').setRelation(false).alias('m').join('fw_task as fw on fw.id = m.taskid').where(where).count();
    }
    async function hbfk(){//回报反馈
      //回报反馈 13 17 19
      let sql = "SELECT COUNT(*) AS c FROM `matter` AS m LEFT JOIN fw_task as fw on fw.id = m.taskid WHERE " +
        "(( fw.businessID = 13 ) AND ( fw.deptID_now = " + userInfo.orgID + " )) OR " +
        "(( fw.businessID = 17 ) AND ( (fw.agent = '" + data.userId + "' ) OR (fw.deptID_now = "+ userInfo.orgID +") )) OR " +
        "(( fw.businessID = 19 ) AND ( fw.charger = '" + data.userId + "' ))";
      let sum = await think.model('matter').query(sql);
      return sum[0].c
    }
    async function ldsp(){//领导审批
      //领导审批 2 4 8 10 11 12 14 18 20 23 26 29 32 // 10完结事项关闭 12已存信
      let where = {
        'fw.businessID': ['IN', [2,4,8,20,23,26,29,32,11,14,16]],
        'fw.deptID_now': userInfo.orgID
      }
      return await think.model('matter').setRelation(false).alias('m').join('fw_task as fw on fw.id = m.taskid').where(where).count();
    }
    let back = await Promise.all([xfqb(),xfdj(),wsbz(),jbzs(),hbfk(),ldsp()]);

    return this.success({
      "xfqb":back[0],
      "xfdj":back[1],
      "wsbz":back[2],
      "jbzs":back[3],
      "hbfk":back[4],
      "ldsp":back[5],
    })
  }
  // 首页 全年各市及辖区 登记数量
  async regionMatterCountAction(){
    let back = [];
    let dept = await this.model('sys_dept').where({'type':[3,4]}).select();
    let city = [];
    dept.forEach(function(item) {
      if (item.type === 3){
        city.push({"id":item.id,"deptName":item.deptName,"longitude":item.longitude,"latitude":item.latitude,"region":[item.id]});
      }
    });
    dept.forEach(function(d) {
      if (d.type === 4){
        city.forEach(function(c) {
          if (c.id === d.parentID){
            c.region.push(d.id)
          }
        })
      }
    });
    for (const item of city){
      let where = {
        "matter.taskid":['!=',null],
        "matter.createTime":['between', moment().startOf('year').format('YYYY-MM-DD') + ',' + moment().endOf('year').add(1,'day').format('YYYY-MM-DD')],
        "sys_user.dictValue":['IN',item.region]
      }
      let count = await think.model('matter').join('sys_user on sys_user.user_name = matter.createAccount').where(where).count();
      back.push({
        "deptName":item.deptName,
        "deptID":item.id,
        "longitude":item.longitude,
        "latitude":item.latitude,
        "count":count,
      })
    }
    return this.success(back)
  }
  // 首页 全年每月 登记数量
  async monthMatterCountAction(){
    let back = [];
    for (let i = 0; i < 12; i++){
      let where = {
        "taskid":['!=',null],
        "createTime":['between', moment().month(i).startOf('month').format('YYYY-MM-DD') + ',' + moment().month(i+1).startOf('month').format('YYYY-MM-DD')],
      }
      let count = await think.model('matter').where(where).count();
      back.push({
        "month":moment().month(i).format('YYYY-MM'),
        "count":count,
      });
    }
    return this.success(back)
  }
  // 全年4种信访类型 登记数量
  async typeMatterCountAction(){
    let where = 'matter.taskid IS NOT NULL AND matter.createTime BETWEEN "' + moment().startOf('year').format('YYYY-MM-DD') +
      '" AND "' + moment().endOf('year').add(1,'day').format('YYYY-MM-DD') + '" ';
    let sql = 'SELECT activity.registerTypeID ,activity.registerType, COUNT(activity.registerType) AS count FROM ' +
      'matter LEFT JOIN activity on activity.id = matter.activityID WHERE '+ where + 'GROUP BY activity.registerTypeID';
    let count = await think.model('matter').query(sql);
    return this.success(count)
  }
  // 全年lfReason信访诉求 登记数量
  async lfReasonMatterCountAction(){
    let where = 'taskid IS NOT NULL AND createTime BETWEEN "' + moment().startOf('year').format('YYYY-MM-DD') + '" AND "' +
      moment().endOf('year').add(1,'day').format('YYYY-MM-DD') + '" ';
    let sql = 'SELECT lfReasonID ,lfReason, COUNT(lfReason) AS count FROM matter WHERE '+ where + 'GROUP BY lfReasonID';
    let count = await think.model('matter').query(sql);
    return this.success(count)
  }
  // 全年belongs流转情况分析
  async belongsCountAction(){
    let where = 'fw_task.businessID = 99 AND fw_task.c_time BETWEEN "' + moment().startOf('year').format('YYYY-MM-DD') +
      '" AND "' + moment().endOf('year').add(1,'day').format('YYYY-MM-DD') + '" ';
    let sql = 'SELECT matter.belongsID ,matter.belongs, COUNT(matter.belongs) AS count FROM ' +
      'matter LEFT JOIN fw_task on fw_task.id = matter.taskid WHERE '+ where + 'GROUP BY matter.belongsID';
    let count = await think.model('matter').query(sql);
    //
    let back = [
      {"belongs":"人大","count":0},
      {"belongs":"政府","count":0},
      {"belongs":"监察委","count":0},
      {"belongs":"法院","count":0},
      {"belongs":"检察院","count":0},
      {"belongs":"其他方面","count":0},
      {"belongs":"公安行政","count":0},
      {"belongs":"公安","count":0},
      {"belongs":"司法","count":0},
    ];
    count.forEach(function(item) {
      switch (item.belongsID.substr(0,3)) {
        case "001":
          back[0].count = back[0].count + item.count;
          break;
        case "002":
          back[1].count = back[1].count + item.count;
          break;
        case "003":
          back[2].count = back[2].count + item.count;
          break;
        case "004":
          back[3].count = back[3].count + item.count;
          break;
        case "005":
          back[4].count = back[4].count + item.count;
          break;
        case "006":
          back[5].count = back[5].count + item.count;
          break;
        case "007":
          back[6].count = back[6].count + item.count;
          break;
        case "008":
          back[7].count = back[7].count + item.count;
          break;
        case "009":
          back[8].count = back[8].count + item.count;
          break;
      }
    });
    //
    return this.success(back)
  }
  // 全年热点问题标签
  async hotLabelCountAction(){
    // type标签类型1热点标签，2个人标签
    let where = 'labelName IS NOT NULL AND createTime BETWEEN "' + moment().startOf('year').format('YYYY-MM-DD') +
      '" AND "' + moment().endOf('year').add(1,'day').format('YYYY-MM-DD') + '" ';
    let sql = 'SELECT labelName, type, COUNT(labelName) AS count FROM label_count WHERE '+ where + 'GROUP BY labelName, type';
    let count = await think.model('label_count').query(sql);
    return this.success(count)
  }
  // 互联网最近提交(未筛选)20条动态online
  async onlineLatelySubmitAction(){
    let where = {
      "state":0
    };
    let back = await think.model('online').where(where).limit(20).order("time DESC").select();
    return this.success(back)
  };

  // 全网近一周信访事项提交动态
  async matterLatelySubmitAction(){
    let where = {
      "fw.businessID":2,
      "m.createTime":['between', moment().add(-7,'day').format('YYYY-MM-DD') + ',' + moment().add(1,'day').format('YYYY-MM-DD')],
    };
    let back = await think.model('matter').setRelation(false).alias('m').where(where).join('fw_task as fw on fw.id = m.taskid')
      .field('m.createTime,m.xfName').order("m.createTime DESC").select();
    return this.success(back)
  }
  // 全年 市辖各县 分别登记数量
  // 传地区sys_dept表地区regionAdminNo   deptID
  async regionCountAction(){
    let data = this.post();
    let back = [];
    let dept = await this.model('sys_dept').where({'regionAdminNo':data.deptID,'RegionAdminNo':['like',data.deptID.toString().substr(0,4) + '%'],_logic: 'OR'}).select();
    // let dept = await this.model('sys_dept').where({'id':data.deptID,'parentID':data.deptID,_logic: 'OR'}).select();
    for (const item of dept){
      let where = {
        "matter.taskid":['!=',null],
        "matter.createTime":['between', moment().startOf('year').format('YYYY-MM-DD') + ',' + moment().endOf('year').add(1,'day').format('YYYY-MM-DD')],
        "sys_user.dictValue":['IN',item.id]
      };
      // 全年登记总数
      let count = await think.model('matter').join('sys_user on sys_user.user_name = matter.createAccount').where(where).count();
      // 月信访登记总量
      where["matter.createTime"] = ['between', moment().startOf('month').format('YYYY-MM-DD') + ',' + moment().endOf('month').add(1,'day').format('YYYY-MM-DD')]
      let monthCount = await think.model('matter').join('sys_user on sys_user.user_name = matter.createAccount').where(where).count();
      // 异常登记数量 以及异常类型
      let abnormalWhere = {
        "matter.taskid":['!=',null],
        "matter.createTime":['between', moment().startOf('year').format('YYYY-MM-DD') + ',' + moment().endOf('year').add(1,'day').format('YYYY-MM-DD')],
        "sys_user.dictValue":['IN',item.id],
        "activity.isAbnormal":1
      }
      let abnormal = await think.model('matter').join('sys_user on sys_user.user_name = matter.createAccount')
        .join('activity on activity.id = matter.activityID').where(abnormalWhere).count();
      // if (abnormal > 0 ){
      //   // 如果有异常访
      //   let abnormalID
      // }
      back.push({
        "deptName":item.deptName,
        "deptID":item.id,
        "longitude":item.longitude,
        "latitude":item.latitude,
        "count":count,
        "monthCount":monthCount,
        "abnormal":abnormal,
      })
    }
    return this.success(back)
  }
  // 全年4种信访类型 每月未完成数量
  async unfinishedMatterAction(){
    let back = [];
    for (let i = 0; i < 12; i++){
      let where = 'fw_task.businessID != 99 AND activity.registerTypeID IS NOT NULL AND matter.createTime  BETWEEN "' +
        moment().month(i).startOf('month').format('YYYY-MM-DD') + '" AND "' + moment().month(i+1).startOf('month').format('YYYY-MM-DD') + '" ';
      let sql = 'SELECT activity.registerTypeID ,activity.registerType, COUNT(activity.registerType) AS count FROM ' +
        'matter LEFT JOIN activity on activity.id = matter.activityID LEFT JOIN fw_task on fw_task.id = matter.taskid WHERE '+
        where + 'GROUP BY activity.registerTypeID';
      let count = await think.model('matter').query(sql);
      back.push({
        "month":moment().month(i).format('YYYY-MM'),
        "data":count,
      })
    }
    return this.success(back)
  }
  // 月度省市登记数量
  async regionMonthAction(){
    // let dept = await this.model('sys_dept').where({'type':['IN',[2,3]]}).select();
    let dept = await this.model('sys_dept').where({'type':3,'id':2, _logic: 'OR'}).select();
    let back = [];
    for (const item of dept){
      let where = {
        "matter.taskid":['!=',null],
        "matter.createTime":['between', moment().startOf('month').format('YYYY-MM-DD') + ',' + moment().endOf('month').add(1,'day').format('YYYY-MM-DD')],
        "sys_user.dictValue":['IN',item.id]
      };
      let monthCount = await think.model('matter').join('sys_user on sys_user.user_name = matter.createAccount').where(where).count();
      back.push({
        "deptName":item.deptName,
        "deptID":item.id,
        "longitude":item.longitude,
        "latitude":item.latitude,
        "monthCount":monthCount,
      })
    }
    let countWhere = {
      "createTime":['between', moment().startOf('month').format('YYYY-MM-DD') + ',' + moment().endOf('month').add(1,'day').format('YYYY-MM-DD')],
      "taskid":['!=',null]
    }
    let count = await this.model('matter').where(countWhere).count();
    let data = {
      "count":count,
      "detail":back
    }
    return this.success(data)
  }
  // 去年和今年每月登记数量对比
  async compareCountAction(){
    let now = [];
    let last = [];
    for (let i = 0; i < 12; i++){
      let whereNow = {
        "taskid":['!=',null],
        "createTime":['between', moment().month(i).startOf('month').format('YYYY-MM-DD') + ',' + moment().month(i+1).startOf('month').format('YYYY-MM-DD')],
      }
      let whereLast = {
        "taskid":['!=',null],
        "createTime":['between', moment().month(i).add(-1,'year').startOf('month').format('YYYY-MM-DD') + ',' + moment().month(i+1).add(-1,'year').startOf('month').format('YYYY-MM-DD')],
      }
      let countNow = await think.model('matter').where(whereNow).count();
      let countLast = await think.model('matter').where(whereLast).count();
      now.push({
        "month":moment().month(i).format('YYYY-MM'),
        "count":countNow,
      });
      last.push({
        "month":moment().add(-1,'year').month(i).format('YYYY-MM'),
        "count":countLast,
      });
    }
    return this.success({"now":now,"last":last})
  }
  // 小红点详细
  async tipsAction(){
    //qb_qs信访签办-上级信访件签收           22 deptID_now
    //qb_bl信访签办-办理                     21 deptID_now
    //hb_hb回报反馈-向上回报反馈             17 deptID_now
    //hb_zb回报反馈-自办填报                 13 deptID_now
    //ld_dj领导审批-信访登记审批             2,32 deptID_now
    //ld_jb领导审批-交办审批                 4 deptID_now
    //ld_zs领导审批-转送审批                 8,26,29 deptID_now
    //ld_zb领导审批-自办审批                 37 deptID_now
    //ld_qs领导审批-签收上级件审批           23 deptID_now
    //ld_js领导审批-接收回报反馈审批         20 deptID_now
    //ld_xs领导审批-向上回报反馈审批         18 deptID_now
    //ld_wj领导审批-完结事项关闭             10,11,12,14 deptID_now
    //hb_hbZ回报反馈-向上回报反馈（代办）     17 deptID_now(职能)/agent(代办)
    //qb_bjZ信访签办-本级信访件签收（代办）   15 deptID_now(职能)/agent(代办)
    //ld_qsZ领导审批-签收本级件审批（代办）   16 deptID_now(职能)/agent(代办)
    //ld_xsZ领导审批-向上回报反馈审批（代办） 18 deptID_now(职能)/agent(代办)
    //ws_nh文书编制-拟函呈批                 3 charger
    //ws_bh文书编制-函件编号                 5 charger
    //ws_zs文书编制-转送单编制               7,25,28 charger
    //jb_zb交办转送-待转办                   6,9,27,30 charger
    //hb_js回报反馈-接收回报反馈             19 charger
    //dj_th001信访登记-审批退回                 24 charger registerTypeID"001,002,003,004"
    //dj_sp001信访登记-待审批                   2 createAccount registerTypeID"001,002,003,004"
    //dj_tj001信访登记-未提交                   registerTypeID"001,002,003,004" submit=0
    //dj_zb信访登记-待甄别                   "intranet/getList" state=0
    //dj_dj信访登记-待登记                   "intranet/getList" state=1 registerState=1
    //dj_gz信访登记-告知单                   "matter/tellMatterList"//暂不做
    //dh_lfjt_all人代会版-来访接谈                   34 deptID_now
    //***********************
    let data = this.post();
    let back = {
      'qb_bjZ':0,//信访签办-本级信访件签收（代办）
      'ld_qsZ':0,//领导审批-签收本级件审批（代办）
      'hb_hbZ':0,//回报反馈-向上回报反馈（代办）
      'ld_xsZ':0,//领导审批-向上回报反馈审批（代办）
      'dh_lfjt_all':0//人代会版-来访接谈
    };
    let userInfo = await this.getUserInfo(data.userId);
    let sql = '';
    // 判断职能单位还是人大
    if (userInfo.isRenDa === 1) { //1是人大机构，0是职能单位
      sql = 'SELECT fw_task.businessID,COUNT(*) AS count FROM matter LEFT JOIN fw_task ON fw_task.id = matter.taskid ' +
        'WHERE fw_task.businessID IN (15,16,17,18) AND fw_task.agent = "'+ data.userId +'" GROUP BY fw_task.businessID';
    }else {
      sql = 'SELECT fw_task.businessID,COUNT(*) AS count FROM matter LEFT JOIN fw_task ON fw_task.id = matter.taskid ' +
        'WHERE fw_task.businessID IN (15,16,17,18,34) AND fw_task.deptID_now = "'+ userInfo.orgID +'" GROUP BY fw_task.businessID';

    }
    let zn = await this.model('matter').query(sql);
    zn.forEach(function(item) {
      if (item.businessID === 15){
        back['qb_bjZ'] = item.count
      }
      if (item.businessID === 16){
        back['ld_qsZ'] = item.count
      }
      if (item.businessID === 17){
        back['hb_hbZ'] = item.count
      }
      if (item.businessID === 18){
        back['ld_xsZ'] = item.count
      }
      if (item.businessID === 34){
        back['dh_lfjt_all'] = item.count
      }
    });
    if (userInfo.isRenDa === 1){ //1是人大机构，0是职能单位
      //人大机构，先给back赋值
      back['qb_qs'] = 0;//信访签办-上级信访件签收
      back['qb_bl'] = 0;//信访签办-办理
      back['hb_hb'] = 0;//回报反馈-向上回报反馈
      back['hb_zb'] = 0;//回报反馈-自办填报
      back['ld_dj'] = 0;//领导审批-信访登记审批
      back['ld_jb'] = 0;//领导审批-交办审批
      back['ld_zs'] = 0;//领导审批-转送审批
      back['ld_zb'] = 0;//领导审批-自办审批
      back['ld_qs'] = 0;//领导审批-签收上级件审批
      back['ld_js'] = 0;//领导审批-接收回报反馈审批
      back['ld_xs'] = 0;//领导审批-向上回报反馈审批
      back['ld_wj'] = 0;//领导审批-完结事项关闭
      back['ws_nh'] = 0;//文书编制-拟函呈批
      back['ws_bh'] = 0;//文书编制-函件编号
      back['ws_zs'] = 0;//文书编制-转送单编制
      back['jb_zb'] = 0;//交办转送-待转办
      back['hb_js'] = 0;//回报反馈-接收回报反馈
      back['dj_th001'] = 0;//信访登记-审批退回   来访              24 charger registerTypeID"001,002,003,004"
      back['dj_th002'] = 0;//信访登记-审批退回   来信
      back['dj_th003'] = 0;//信访登记-审批退回   来电
      back['dj_th004'] = 0;//信访登记-审批退回   网上
      // back['dj_sp001'] = 0;//信访登记-待审批     来访              2 createAccount registerTypeID"001,002,003,004"
      // back['dj_sp002'] = 0;//信访登记-待审批     来信
      // back['dj_sp003'] = 0;//信访登记-待审批     来电
      // back['dj_sp004'] = 0;//信访登记-待审批     网上
      back['dj_tj001'] = 0;//信访登记-未提交     来访                  registerTypeID"001,002,003,004" submit=0
      back['dj_tj002'] = 0;//信访登记-未提交     来信
      back['dj_tj003'] = 0;//信访登记-未提交     来电
      back['dj_tj004'] = 0;//信访登记-未提交     网上
      back['dj_zb'] = 0;//信访登记-待甄别
      back['dj_dj'] = 0;//信访登记-待登记
    }else {
      back['xfqb_all'] = back.qb_bjZ;
      back['hbfk_all'] = back.hb_hbZ;
      back['ldsp_all'] = back.ld_qsZ +  back.ld_xsZ;
      return this.success(back);// 职能单位，直接返回
    }
    let sql_deptID = 'SELECT c_creater,fw_task.businessID,COUNT(*) AS count FROM matter LEFT JOIN fw_task ON fw_task.id = matter.taskid ' +
      'WHERE fw_task.businessID IN (22,21,17,13,2,32,4,8,26,29,37,23,20,18,10,11,12,14) AND fw_task.deptID_now = "'+ userInfo.orgID +'" GROUP BY fw_task.businessID';
    let sqlDeptID = await this.model('matter').query(sql_deptID);
    sqlDeptID.forEach(function(item) {
      switch (item.businessID) {
        case 22:
          back.qb_qs = back.qb_qs + item.count;
          break;
        case 21:
          back.qb_bl = back.qb_bl + item.count;
          break;
        case 17:
          back.hb_hb = back.hb_hb + item.count;
          break;
        case 13:
          back.hb_zb = back.hb_zb + item.count;
          break;
        case 2:
        case 32:
          back.ld_dj = back.ld_dj + item.count;
          break;
        case 4:
          back.ld_jb = back.ld_jb + item.count;
          break;
        case 8:
        case 26:
        case 29:
          back.ld_zs = back.ld_zs + item.count;
          break;
        case 37:
          back.ld_zb = back.ld_zb + item.count;
          break;
        case 23:
          back.ld_qs = back.ld_qs + item.count;
          break;
        case 20:
          back.ld_js = back.ld_js + item.count;
          break;
        case 18:
          back.ld_xs = back.ld_xs + item.count;
          break;
        case 10:
        case 11:
        case 12:
        case 14:
          back.ld_wj = back.ld_wj + item.count;
          break;
      }
    });
    let sql_charger = 'SELECT fw_task.businessID,COUNT(*) AS count FROM matter LEFT JOIN fw_task ON fw_task.id = matter.taskid ' +
      'WHERE fw_task.businessID IN (3,5,7,25,28,6,9,27,30,19) AND fw_task.charger = "'+ data.userId +'" GROUP BY fw_task.businessID';
    let sqlCharger = await this.model('matter').query(sql_charger);
    sqlCharger.forEach(function(item) {
      switch (item.businessID) {
        case 3:
          back.ws_nh = back.ws_nh + item.count;
          break;
        case 5:
          back.ws_bh = back.ws_bh + item.count;
          break;
        case 7:
        case 25:
        case 28:
          back.ws_zs = back.ws_zs + item.count;
          break;
        case 6:
        case 9:
        case 27:
        case 30:
          back.jb_zb = back.jb_zb + item.count;
          break;
        case 19:
          back.hb_js = back.hb_js + item.count;
          break;
      }
    });
    let sql_th = 'SELECT ac.registerTypeID,COUNT(*) AS count FROM matter LEFT JOIN fw_task ON fw_task.id = matter.taskid ' +
      'LEFT JOIN activity AS ac ON ac.matterID = matter.id WHERE fw_task.businessID = 24 AND fw_task.charger = "'+ data.userId +'" GROUP BY ac.registerTypeID';
    let sqlTh = await this.model('matter').query(sql_th);
    sqlTh.forEach(function(item) {
      switch (item.registerTypeID) {
        case '001':
          back.dj_th001 = back.dj_th001 + item.count;
          break;
        case '002':
          back.dj_th002 = back.dj_th002 + item.count;
          break;
        case '003':
          back.dj_th003 = back.dj_th003 + item.count;
          break;
        case '004':
          back.dj_th004 = back.dj_th004 + item.count;
          break;
      }
    });
    // let sql_sp = 'SELECT ac.registerTypeID,COUNT(*) AS count FROM matter LEFT JOIN fw_task ON fw_task.id = matter.taskid ' +
    //   'LEFT JOIN activity AS ac ON ac.matterID = matter.id WHERE fw_task.businessID = 2 AND matter.createAccount = "'+ userInfo.user_name +'" GROUP BY ac.registerTypeID';
    // let sqlSp = await this.model('matter').query(sql_sp);
    // sqlSp.forEach(function(item) {
    //   switch (item.registerTypeID) {
    //     case '001':
    //       back.dj_sp001 = back.dj_th001 + item.count;
    //       break;
    //     case '002':
    //       back.dj_sp002 = back.dj_sp002 + item.count;
    //       break;
    //     case '003':
    //       back.dj_sp003 = back.dj_sp003 + item.count;
    //       break;
    //     case '004':
    //       back.dj_sp004 = back.dj_sp004 + item.count;
    //       break;
    //   }
    // });
    let sql_tj = 'SELECT registerTypeID,COUNT(*) AS count FROM activity  WHERE meetingID IS NULL AND submit = 0 AND' +
      ' createAccount = "'+ userInfo.user_name +'" GROUP BY registerTypeID';
    let sqlTj = await this.model('matter').query(sql_tj);
    sqlTj.forEach(function(item) {
      switch (item.registerTypeID) {
        case '001':
          back.dj_tj001 = back.dj_tj001 + item.count;
          break;
        case '002':
          back.dj_tj002 = back.dj_tj002 + item.count;
          break;
        case '003':
          back.dj_tj003 = back.dj_tj003 + item.count;
          break;
        case '004':
          back.dj_tj004 = back.dj_tj004 + item.count;
          break;
      }
    });
    let sql_online = 'SELECT registerState,state,COUNT(*) AS count FROM `online` WHERE state IN (0,1) AND djRegionID = ' +
      userInfo.dictValue + ' GROUP BY state,registerState';
    let sqlOnline = await this.model('matter').query(sql_online);
    sqlOnline.forEach(function(item) {
      if (item.state === 0){
        back.dj_zb = back.dj_zb + item.count;
      }
      if (item.state === 1 && item.registerState === 1){
        back.dj_dj = back.dj_dj + item.count;
      }
    });
    back['xfqb_all'] = back.qb_bjZ + back.qb_bl + back.qb_qs;// 信访签办总数
    back['lf_all'] = back.dj_tj001 + back.dj_th001;//来访登记总数
    back['lx_all'] = back.dj_tj002 + back.dj_th002;//来信登记总数
    back['ld_all'] = back.dj_tj003 + back.dj_th003;//来电登记总数
    back['lw_all'] = back.dj_tj004 + back.dj_th004 + back.dj_dj + back.dj_zb;//网上登记总数
    back['xfdj_all'] = back.lf_all + back.lx_all + back.ld_all + back.lw_all;// 信访登记总数
    back['jb_all'] = back.ws_bh + back.ws_nh;// 交办函总数
    back['zs_all'] = back.ws_zs;// 转送单总数
    back['wsbz_all'] = back.jb_all + back.zs_all;// 文书编制总数
    back['jbzs_all'] = back.jb_zb;// 交办转送总数
    back['xs_all'] = back.hb_hb + back.hb_hbZ;// 向上回报反馈总数
    back['js_all'] = back.hb_js;// 接受回报反馈总数
    back['zb_all'] = back.hb_zb;// 自办填报总数
    back['hbfk_all'] = back.xs_all + back.js_all + back.zb_all;// 回报反馈总数
    back['ws_all'] = back.ld_jb + back.ld_zs;// 信访文书审批总数
    back['hk_all'] = back.ld_xs + back.ld_xsZ;// 向上回报反馈审批总数
    back['ldsp_all'] = back.ld_dj + back.ld_zb + back.ws_all + back.hk_all + back.ld_qsZ + back.ld_qs + back.ld_js + back.ld_xs + back.ld_wj;// 领导审批总数
    return this.success(back)
  }

  //内网app消息提示
  async getAppTipsAction(){
    const data = this.post();
    let userInfo = await this.getUserInfo(data.userId);
    let where = {
      _complex:[
        {
          'fw.businessID': ["IN",[2,23,37,4,8,29,26,23,20,10,11,12,14]],
          "fw.deptID_now" : userInfo.orgID
        },
        // {
        //   'fw.businessID': ["IN",[16,18]],
        //   'fw.agent' : data.agent,
        // },
        {
          'fw.businessID': ["IN",[16,18]],
          'fw.deptID_now' : userInfo.orgID,
        }
      ],
      _logic:"or"
    }
    // let matter = await this.model('matter').alias('m')
    let matter = await this.model('matter').setRelation('handle_log').alias('m')
      .field('m.*,fw.businessID,fw.dealType_pre,fw.deptID_create,fw.deptName_create,fw.isBack').join({
        table: 'fw_task',
        join: 'left',
        as: 'fw',
        on: ['taskid', 'id']
      }).where(where).order(['m.createTime desc']).select();
    for (let item of matter){
      let last = item.handle_log[item.handle_log.length - 1]
      switch (item.businessID) {
        case 2://信访登记审批
        case 32://信访登记审批
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "信访登记审批";
          break;
        case 37:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "自办审批";
          break;
        case 4:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "交办审批";
          break;
        case 8:
        case 29:
        case 26:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "转送审批";
          break;
        case 20:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "接收回报反馈审批";
          break;
        case 23:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "签收上级件审批";
          break;
        case 16:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "签收本级件审批";
          break;
        case 18:
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "向上回报反馈审批";
          break;
        case 10:// 待接谈
        case 11:// 已存件
        case 12:// 已存信
        case 14:// 已自办待关闭
          item["tips"] = "来自" + last.createOrgName + last.createUserName + "完结事项审批";
          break;
        default:
          item["tips"] = "其他审批"
      }
    }
    return this.success(matter)
  }
  // 即时通讯消息提示
  async getUserMsgAction(){
    const data = this.post();
    let count = await this.model('user_message').where({"isread":0,"receiveuser":data.userId}).count();
    return this.success(count);
  }
};
