const Base = require('./../base.js');

module.exports = class extends Base {
  async friendListAction() {
    let token = this.post().token;
    let userId = this.checkAuth(token);
    let mine = await await this.model('sys_user').where({"user_id":userId}).find();
    let user = await this.model('sys_user').join('sys_organization on sys_organization.id = sys_user.orgID')
      .where({"sys_user.status":1,"del_flag":1,"user_id":["!=",userId]}).field('sys_user.*,sys_organization.orgName').select();
    let friend = [];
    user.forEach(function(item) {
      let state = 0;
      for (let i = 0;i<friend.length;i++){
        if (friend[i].groupname === item.orgName){
          state = 1;
          break;
        }
      }
      if (state === 0){// friend 中不含，则插入
        friend.push({
          "groupname":item.orgName,
          "id":item.orgID,
          "list":[]
        })
      }
    });
    friend.forEach(function(items) {
      user.forEach(function(u) {
        if (u.orgName === items.groupname){
          items.list.push({
            "username": u.name,
            "id": u.user_id,
            "avatar": "/layui/images/0.jpg",
            "sign": "",
            "status": u.status
          })
        }
      })
    });
    return this.json({
      "code": 0, //0表示成功，其它表示失败
      "msg": "", //失败信息
      "data":{
        "mine": {
          "username": mine.name, //我的昵称
          "id": userId, //我的ID
          "status": "", //在线状态 online：在线、hide：隐身
          "sign": "", //我的签名
          "avatar": "/layui/images/0.jpg" //我的头像
        },
        "friend": friend,
        "group":[]
      }
    })
  }
}
