const Base = require('./../base.js');

module.exports = class extends Base  {
  //申请授权
  /**
   * showdoc
   * @catalog 授权
   * @title 授权申请
   * @description 授权申请接口
   * @method get
   * @url http://127.0.0.1:8360/authorize/applyAuthorize
   * @param authorizeUser 必选 string 授权人
   * @param authorizeObject 必选 string 被授权人
   * @param startTime 必选 datetime 开始时间
   * @param endTime 必选 datetime 结束时间
   * @return {"errno": 0, "errmsg":"", "data":}
   * @return_param errno  int 错误号，0代表成功
   * @return_param errmsg  string 错误信息
   */
  async applyAuthorizeAction() {
    const param = this.post()
    const result = await this.model('authorize').add(param).catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err);
    })
    if (think.isError(result)) {
      return this.fail(5001, '申请失败')
    }
    return this.success()
  }
  
   /**
   * showdoc
   * @catalog 授权
   * @title 获取所有用户
   * @description 获取所有用户接口
   * @method get
   * @url http://127.0.0.1:8360/authorize/getAllUser
   * @return {"errno": 0, "errmsg":"", "data":[{"name":"张三","user_id": "qqqqqq"}]}
   * @return_param errno  int 错误号，0代表成功
   * @return_param errmsg  string 错误信息
   * @return_param name  string 真实姓名
   * @return_param user_id  string 用户user_id
   */
  //获取所有用户
  async getAllUserAction() {
    const userList = await this.model('sys_user').fied('name,user_id').select().catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err);
    });

    if (think.isError(userList)) {
      return this.fail(5003, '获取所有用户失败')
    };
    return this.success(userList);
  }

  
}