const Base = require('../base.js');

module.exports = class extends Base {
  //获取行政区域
  async getAdminTreeAction(){
    const param = this.post();
    // 判断该用户是否是超级管理员
    // const userRole = await this.model('sys_user_role').where({role_id:1,user_id:param.userId}).find();
    // let res = {}
    // //为空不是超级管理员，需要登录者的地区
    // if (think.isEmpty(userRole)) {
    //   const userDept = await this.model('sys/sys_user').where({user_id: param.userId}).find();
    //   //?有疑惑
    //   res.difineRes = userDept.zone
    // } else {
    //   //是超级管理员获取所有的地区
    // }
    let adminTree = await this.model('sys_dept').select();
    adminTree = this.getDictTree(adminTree, 'id', 'parentID');
    return this.success(adminTree);
  }
   /**
   * showdoc
   * @catalog 系统管理/机构
   * @title 获取机构
   * @description 获取机构接口
   * @method post
   * @url http://127.0.0.1:8360/sys/common/getOrgList
   * @param zoneId 必选 int  地区id
   * @return {"errno": 0, "errmsg":"", "data":[{orgName": "人大常务"}]}
   * @return_param orgName string 机构名称
   */
  async getOrgListAction() {
    const param = this.post();
    // const orgRes = await this.model('sys_organization').field('orgName,id').where({deptID: param.zoneId,isRenDa:1}).select();
    const orgRes = await this.model('sys_organization').field('orgName,id').where({deptID: param.zoneId}).select();
    return this.success(orgRes)
  }
  /**
   * showdoc
   * @catalog 系统管理/机构
   * @title 获取届次
   * @description 获取届次接口
   * @method post
   * @url http://127.0.0.1:8360/sys/common/getSessionList
   * @param orgID 必选 int  组织id
   * @return {"errno": 0, "errmsg":"", "data":[{session": "11届"}]}
   * @return_param session string 届次
   */
  async getSessionListAction() {
    const param = this.post();
    const sessionRes = await this.model('sys_session').where({deptNameID: param.orgID}).select();
    return this.success(sessionRes);
  }
  /**
   * showdoc
   * @catalog 系统管理/机构属性
   * @title 获取机构属性
   * @description 获取机构属性接口
   * @method post
   * @url http://127.0.0.1:8360/sys/common/getInfo
   * @param orgID 必选 int  组织id
   * @return {"errno": 0, "errmsg":"", "data":}
   * @return_param deptName string 函件署名
   * @return_param passTitle string 转送单头
   * @return_param deptTitle string 函件头
   * @return_param orgJc string 机构简称
   * @return_param depJc string 地区简称
   * @return_param regionAdminNo string 行政地区编码6位
   */
  async getInfoAction(){
    const param = this.post();
    let org = await this.model('sys_organization').alias('so').join('sys_dept on sys_dept.id = so.deptID').where({'so.id':param.orgID})
      .field("so.deptName,so.jc as orgJc,so.deptTitle,so.passTitle,sys_dept.regionAdminNo,sys_dept.jc as depJc").find();
    return this.success(org)
  }

}
