const Base = require('./../base.js');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }

  async delDicAction() {
    const param = this.post();
    let del_param = await this.model('dictionary').field('dictID,dictValue').where({id:param.id}).find().catch((err) => {
       console.log(err)
    })

    if (del_param) {
      let sql = "call proc_delete_dic('" + del_param.dictID + "','" + del_param.dictValue + "')";
      let result = await this.model('dictionary').query(sql);
      return this.success(result)
    } else {
      return this.fail(1000, 'Not find this Data');
    }
  }

   /**
   * showdoc
   * @catalog 系统管理/字典管理
   * @title 字典列表
   * @description 字典列表接口
   * @method post
   * @url http://127.0.0.1:8360/sys/dictionary/getDictionaryList
   * @param dictID string 必填 字典值
   * @param description string 选填 描述
   * @return {"errno": 0, "errmsg":"", "data":[{"dictName":1,"dictID":1,"dictValue":10,"description":1,"shortDesc":"admin","parentValue":1,"isExistchild":0,"descSpell":"jash"}]}
   * @return_param errno  int 错误号，0代表成功
   * @return_param errmsg  string 错误信息
   * @return_param dictName  string 字典名称
   * @return_param dictID  string 字典类型
   * @return_param description  string 描述
   * @return_param name string 描述
   * @return_param shortDesc string 简述
   * @return_param parentValue string 父值
   * @return_param isExistchild int 是否存在下一级 0不存在，1存在
   * @return_param descSpell string 简拼
   */
  async getDictionaryListAction() {
    let param = this.post();
    let whereParam = {dictID:param.dictID}
    if (param.description) {
      whereParam.description = ['like', '%' + param.description + '%']
    }
    let back = await this.model('dictionary').where(whereParam).select().catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err);
    });
    if (think.isError(back)) {
      return this.fail(1002, 'Get dictionaryList error');
    }
    let getMenuTree = () => {
      const tree = [];
      const data = {};
      for (var i in back) {
        data[back[i]['dictValue']+ back[i]['dictID']] = back[i];
      }
      for (var j in back) {
        const bval = back[j];
        const dataP = data[bval['parentValue']+bval['dictID']];
        if (dataP) {
          (!dataP.children) && (dataP.children = []);
          dataP.children.push(bval);
        } else {
          tree.push(bval);
        }
      }
      return tree;
    }
    const fin_data = getMenuTree();
    return this.success(fin_data);
  }

  
  async editDoctionaryAction() {
    const param = this.post();
    let data = await this.model('dictionary').where({id: param.id}).update(param).catch((err) => {
      return think.isError(err) ? err : new Error(err);
    });
    if (think.isError(data)) {
      return this.fail(1003, 'update failed');
    }
    return this.success();
  }

  // async addDoctionaryAction() {
  //   const param = this.post();
  //   console.log(param)
  //   let data = await this.model('dictionary').thenAdd(param,{dictID:param.dictID,dictValue:param.dictValue}).catch((err) => {
  //     return think.isError(err) ? err : new Error(err);
  //   });
  //   if (think.isError(data)) {
  //     return this.fail(1003, 'update failed');
  //   }
  //   return this.success();
  // }
  
  async dictionaryDetailAction() {
    const param = this.get();
    let data = this.model('dictionary').where({id:param.id}).find().catch((err) => {
      return think.isError(err) ? err : new Error(err);
    });
    if (think.isError(data)) {
      return this.fail(1004, "Get dictionary info failed");
    }
    this.success(data);
  }
}
