const request = require('request');
const moment = require('moment');
const sixtytwo = require('sixtytwo');
const util = require('./util');

// 发送短信
async function msg(phone,content) {
  let data = {
    "LoginName":"ahrdxf",
    "Password":"55f5ff201e97eaaa",
    "SmsKind":"808",
    "SendSim":phone,
    "MsgContext":content,
    "ExpSmsId":""
  };
  request({
    url: 'http://sdk.zyer.cn/SmsService/SmsService.asmx/SendEx', // 请求路径
    // url: 'http://118.178.121.100/SmsService/SmsService.asmx/SendEx', // 请求路径
    method: 'POST',//请求方式
    headers: {
      //设置请求头
      'content-type': 'application/x-www-form-urlencoded;charset=utf-8',
    },
    form: data//post参数字符串
  }, function(error, response, body) {
    // 解析xml返回值
    var parseString = require('xml2js').parseString;
    parseString(body, async function (err, result) {
      await think.model('sms_log').add({
        'phone':phone,
        'content':content,
        'code':parseInt(result.Response.Code[0])
      })
    })
    return body
  });
}

// 生成互联网登记信息查询码
async function createInquiryCode(matterID){
  let matter = await think.model('matter').where({"id":matterID}).find();
  let user = await think.model('sys_user').where({"user_name":matter.createAccount}).find();
  let t = moment().format('x');
  // let inquiryCode = Math.random().toString(16).substr(2,4) + parseInt(t).toString(16).substr(4,4);// 查询码
  let inquiryCode = Math.random().toString(16).substr(2,1) + sixtytwo.toString(t);// 查询码
  let add = {
    "inquiryCode":inquiryCode,
    "matterID":matterID,
    "orgID":user.orgID,
    "matterNum":matter.matterNum,
    "taskId":matter.taskid,
  };
  await think.model('inquiry_code').add(add);
  return inquiryCode
}
// "已收悉"短信 或 告知单
async function received(matterID,userId){
  let org = await think.model('sys_organization').join('sys_user on sys_user.orgID = sys_organization.id')
    .where({'sys_user.user_id':userId}).field('sys_organization.*,sys_user.regionAdminNo').find();
  let online = org.isOnline === null || typeof org.isOnline === 'undefined' ? 1 : org.isOnline;// 网上信访，默认否 不开通
  let matter = await think.model('matter').where({'id':matterID}).find();
  if (matter.noticeType !== 1 && matter.noticeType !== 2){
    // 未选择告知方式，不进行告知
    return
  }
  //查询码
  let code = await think.model('inquiry_code').where({'matterID':matterID,'flag':0}).order('createTime DESC').find();
  // 获得模板
  let template = await think.model('template_tell').where({'stage':1,'isOnline':online,'type':matter.noticeType}).find();
  let content = template.content;//内容
  content = content.replace('[信访事项编号]', matter.matterNum);
  content = content.replace('[查询码]', code.inquiryCode);
  content = content.replace('[发送单位]', org.orgName);
  content = content.replace('[网址链接]', '');
  content = content + "【" + org.deptName + "人大信访】";
  let tellLog = {
    'matterID':matterID,
    'mobilePhone':matter.activity.person.mobilePhone,
    'sendType':matter.noticeType,
    'sendPerson':userId,
    'sendOrgID':org.id,
    'isSend':0,//是否发送0发送，1未发送
    'content':content,
    'personID':matter.activity.person.id,
    'personName':matter.activity.person.name,
    'tellCode':matter.noticeType === 1 ? "" : await util.getTellNum(org.regionAdminNo),
    'isRepresent':0,// 已收悉不存在向代表告知
  };
  await think.model('tell_log').add(tellLog);
  if (matter.noticeType === 1){
    //发送短信
    // await httpRequest('post','https://192.9.200.55:8360/msg/msg/sendMsg',{"phone":matter.activity.person.mobilePhone,"content":content});
    await httpRequest('post','https://172.28.50.118/msg/msg/sendMsg',{"phone":matter.activity.person.mobilePhone,"content":content});
    return
  }
  return
}

module.exports = {
  msg,
  createInquiryCode,
  received
}
