// 判断流程
async function process(matterID) {
  const noedRecord = await this.model('node_record').where({'matterID': matterID}).order('time desc').select();
  if (think.isEmpty(noedRecord)) {
    // 为空，未进入流程
  } else if (noedRecord.length === 1) {
    // 无前置节点 下一步为登记审批
  } else {
    // 有前置节点
    const matter = await this.model('matter_state').where({'matterID': matterID}).find();
    // const length = noedRecord.length; // 节点长度
    switch ( noedRecord[0].nodeName ) {
      // 判断最近一个节点
      case '登记审批':
        // 判断去向单位
        if (matter.Department === matter.nextDepartment) {
          // 登记单位与去向单位相同，本级处理
          return '处理';
        } else {
          // 登记单位与去向单位不同，下发
          return '下发';
        }
        break;
      case '处理':
        // 判断去向单位
        if (matter.Department === matter.nextDepartment) {
          // 本级单位与去向单位相同，终结
          return '终结';
        } else {
          // 上一节点处理，本级又不终结，则回报
          return '回报';
        }
        break;
      case '下发':
        return '签收';
        break;
      case '签收':
        // 判断去向单位
        if (matter.Department === matter.nextDepartment) {
          // 本级单位与去向单位相同，处理
          return '处理';
        } else {
          // 本级单位与去向单位不同，下发
          return '下发';
        }
        break;
      case '回报':
        return '审核回报';
      case '审核回报':
        // 判断去向单位
        if (matter.Department === matter.nextDepartment) {
          // 本级单位与去向单位相同，终结
          return '终结';
        } else {
          // 本级单位与去向单位不同，回报
          return '回报';
        }
    }
  }
}
