// const pyfl = require('pyfl').default;
const moment = require('moment');
//获取事项名称
async function getNamespaceByNameRules(activityID, matterID, contentClassifyID) {
  //获取命名规则
  const dictValue = await think.model('name_rules').where({
    dictValue: contentClassifyID
  }).find();
  console.log(dictValue)
  let finalName = "";
  if (!think.isEmpty(dictValue)) {
    const nameRulesToArray = dictValue.nameRules.split('+');
    //验证英文字符串表达式
    const pattern = new RegExp("[A-Za-z]+");
    for (let i = 0; i < nameRulesToArray.length; i++) {
      if (pattern.test(nameRulesToArray[i])) {
        const tableAnd = nameRulesToArray[i].split('*');
        if (tableAnd.indexOf('person') !== -1) {
          //获取首信访人
          let personRes = await getFirstPerson(activityID, tableAnd)
          if (personRes == -1) {
            finalName += ""
          } else {
            finalName += personRes;
          }
        } else {
          //获取事项名称
          finalName += await getAppealLevel(contentClassifyID, matterID, tableAnd)
        }
      } else {
        finalName += nameRulesToArray[i];
      }
    }
  }
  return finalName;
}
//获取首信访人的姓名
async function getFirstPerson(activityID, tableAnd) {
  //获取首信访人
  let personWhere = await think.model('person_activity').field('personID').where({
    activityID: activityID,
    isMain: 1
  }).find();
  if (think.isEmpty(personWhere)) {
    return -1;
  }
  let whereParam = {
    id: personWhere.personID
  };
  const name = await getTabelParam(tableAnd[0], tableAnd[1], whereParam);
  //是否还有其他信访人
  let personCount = await think.model('person_activity').where({
    activityID: activityID
  }).count('id');
  let res = name[tableAnd[1]]
  if (personCount > 1) {
    res += "等"
  }
  return res;
}
//获取问题级别
async function getAppealLevel(dictValue, matterID, tableAnd) {
  //截取字符串长度
  let strLength = parseInt(tableAnd[2]) * 4 + 1;
  console.log("==========" + strLength)
  let dictWhere = dictValue.slice(0, strLength);
  console.log(dictWhere)
  let whereParam = {};
  if (tableAnd[0] === 'matter'){
    whereParam = {'id':matterID}
  }else {
    whereParam = {
      dictID: 'FYN',
      dictValue: dictWhere
    }
  }
  // const whereParam = {
  //   dictID: 'FYN',
  //   dictValue: dictWhere
  // }
  const name = await getTabelParam(tableAnd[0], tableAnd[1], whereParam);
  return name[tableAnd[1]];

}
async function getTabelParam(table, param, whereParam) {
  result = await think.model(table).field(param).where(whereParam).find();
  return result;
}

// 获取年份
function getCurrentYear() {
  let myDate = new Date();
  let tYear = myDate.getFullYear().toString();
  const tYearSub = tYear.slice(2);
  return tYearSub;
}

//获取单位首字母
// function getPinYinFirst(department) {
//   const result = pyfl(department);
//   return result;
// }

//处理行政编号和单位
function handleAdminNoAndDepartment(handlePersonInfo) {
  // const firstSpelling = getPinYinFirst(handlePersonInfo.description);
  const finalRes = handlePersonInfo.regionAdminNo + "RD";
  return finalRes
}
// 2020-12新版获取活动编号，包含区分大会
// isDH 是否大会版，1是，0不是
// code 大会代字，默认''
// regionAdminNo 6位行政区划号
async function getActivityNum(regionAdminNo,isDH,code){
  let activityNum = "";
  let zoneUnit = regionAdminNo + 'RD';
  let sql;
  if (isDH === 1){
    sql = "select * from activity_num where code = '"+ code +"' AND isDH = "+ isDH +" AND zoneUnit='" + zoneUnit + "' for update";
  } else {
    sql = "select * from activity_num where isDH = "+ isDH +" AND zoneUnit='" + zoneUnit + "' for update";
  }
  let res = await think.model('activity_num').query(sql);
  const tYear = getCurrentYear();// 获取年份
  if (res.length > 0) {
    let eidtParam = {
      zoneUnit: zoneUnit,
      yearNum: tYear,
      serialNum: 1,
      isDH: isDH,
      code: code,
      id: res[0].id
    }
    if (isDH === 1){
      activityNum = zoneUnit + tYear + code + "0001";
    } else {
      activityNum = zoneUnit + tYear + "00001";
    }
    if (res[0].yearNum == tYear) {
      let serialNum;
      if (isDH === 1){
        let str = "0000" + (res[0].serialNum + 1).toString();
        serialNum =  code + str.substring(str.length - 4);
      } else {
        let str = "00000" + (res[0].serialNum + 1).toString();
        serialNum =  str.substring(str.length - 5);
      }
      eidtParam.serialNum = res[0].serialNum + 1;
      activityNum = zoneUnit + tYear + serialNum
    }
    //添加或修改数据库,type为1是新增，其他事修改
    const editRes = addOrEditTable(0, eidtParam);
    if (editRes === 0) {
      return 0
    }
  } else {
    if (isDH === 1){
      activityNum = zoneUnit + tYear + code + "0001";
    } else {
      activityNum = zoneUnit + tYear + "00001";
    }
    let insertParam = {
      zoneUnit: zoneUnit,
      yearNum: tYear,
      serialNum: 1,
      isDH: isDH,
      code: code
    }
    const insertRes = addOrEditTable(1, insertParam)
    if (insertRes === 0) {
      return 0
    }
  }
  return activityNum;
}

//获取活动编号
async function getActivityNo(personInfo) {
  let activityNum = "";
  const departSpell = handleAdminNoAndDepartment(personInfo);
  const sql = "select * from activity_num where zoneUnit='" + departSpell + "' for update"
  let res = await think.model('activity_num').query(sql);
  const tYear = getCurrentYear();
  if (res.length > 0) {
    let eidtParam = {
      zoneUnit: departSpell,
      yearNum: tYear,
      serialNum: 1,
      id: res[0].id
    }
    console.log(eidtParam)
    activityNum = departSpell + tYear + "00001";
    if (res[0].yearNum == tYear) {
      let serialNum = padNumber(res[0].serialNum)
      eidtParam.serialNum = res[0].serialNum + 1;
      activityNum = departSpell + tYear + serialNum
    }
    //添加或修改数据库,type为1是新增，其他事修改
    const editRes = addOrEditTable(0, eidtParam);
    if (editRes === 0) {
      return 0
    }
  } else {
    activityNum = departSpell + tYear + "00001";
    let insertParam = {
      zoneUnit: departSpell,
      yearNum: tYear,
      serialNum: 1
    }
    const insertRes = addOrEditTable(1, insertParam)
    if (insertRes === 0) {
      return 0
    }
  }

  return activityNum;
}

// 给事项编号
async function getMatterNo(activityID,matterID){
  let matterList = await think.model('matter').where({"activityID":activityID}).select();
  let activity = await think.model('activity').setRelation(false).where({"id": activityID}).find();
  let usedNum = [];// 已使用的事项编号
  let matter = [];// 未编号的事项
  matterList.forEach(function(item) {
    if (item.matterNum !== null && item.matterNum !== ""){
      usedNum.push(item.matterNum);
    }else {
      matter.push({
        "id":item.id
      })
    }
  });
  if (typeof matterID !== 'undefined') {
    matter = [{"id":matterID}]
  }
  matter.forEach(function(items) {
    for (let i = 1;i <= matterList.length; i++){
      let num = activity.activityNum + i.toString();
      if (usedNum.indexOf(num) === -1){
        items["matterNum"] = num;
        usedNum.push(num);
        break;
      }
    }
  });
  return matter //返回需要更新的matter 以及matterNum
}

//流水号填充0
function padNumber(num) {
  let str = "00000" + (num + 1).toString();
  return str.substring(str.length - 5);
}
//添加或修改数据库,type为1是新增，其他事修改
function addOrEditTable(type, param) {
  if (type == 1) {
    const result = think.model('activity_num').add(param).catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err);
    });
    if (think.isError(result)) {
      return 0
    }
    return 1
  } else {
    const result = think.model('activity_num').where({
      id: param.id
    }).update(param).catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err);
    });
    if (think.isError(result)) {
      return 0
    }
    return 1
  }
}

//获取person_activity表和activity表中的人数
async function getPersonNum(activityID) {
  const actPersonNum = await think.model('activity').field('xfNumber').where({
    id: activityID
  }).find().catch((err) => {
    console.log(err);
    return think.isError(err) ? err : new Error(err);
  })
  const personNum = await think.model('person_activity').where({
    activityID: activityID
  }).select().catch((err) => {
    console.log(err)
    return think.isError(err) ? err : new Error(err);
  });

  if (!think.isError(actPersonNum) && !think.isError(personNum)) {
    let data = {}
    data.actPersonNum = actPersonNum.xfNumber;
    data.personNum = personNum.length;
    return data
  }
  return 0
}

//判断，如果person_activity>activity修改
async function perActMoreAct(data, activityID) {
  if (data.personNum > data.actPersonNum) {
    result = think.model('activity').where({
      id: activityID
    }).update({
      xfNumber: data.personNum
    });
    return result
  }
}

//判断，如果person_activity<activity修改
async function perActLessAct(data, activityID) {
  if (data.personNum < data.actPersonNum) {
    result = think.model('activity').where({
      id: activityID
    }).update({
      xfNumber: data.personNum
    });
    return result
  }
}




/**
 *
 * @title 生成事项查询码，并保存到数据库
 * @param {*} matterID 事项id
 * @param {*} matterStatus 事项状态
 * @param {*} matterStatusID 事项状态id
 * @param {*} startTime 有效期的开始时间
 * @param {*} endTime 有效期的结束时间
 */
async function matterQueryCode(matterID, matterStatus, matterStatusID, startTime, endTime) {
  const code = (new Date()).getTime().toString(36);
  const addParam = {
    queryCode: code,
    startTime: startTime,
    endTime: endTime,
    matterID: matterID,
    matterStatus: matterStatus,
    matterStatusID: matterStatusID
  };
  let res = await think.model('matter_code').add(addParam);
  return res;
}
// 判断事项状态
function judgeState(handleModelID) {
  switch (handleModelID) {
    case '001001':
    case '002001':
    case '003001':
    case '004001':
      return {
        'state': 4, 'stateName': '待拟函'
      };
      break;
    case '001003':
    case '002003':
    case '003003':
    case '004003':
      return {
        'state': 5, 'stateName': '待转交'
      };
      break;
  }
}
// 生成函件编号
async function letterNum(depJc,orgJc,type,orgID){
  //地区代字+单位代字+部门代字+函种代字+[年份]+首位非零数字+"号"
  // 1 + 1 + 1 + 信字(省代会)/信函字(非省代会)/信督字(督办) + [xxxx] + n + 号
  const year = moment().format('YYYY');
  let where = {
    'depJc':depJc,'orgJc':orgJc,'year':year,'type':type,'orgID':orgID // 地区代字，机构代字，年号，函种, 单位id
  };
  //******************
  const model = think.model('letters_num');
  try {
    //
    await model.startTrans();
    // let num = await model.where(where).field('num').find();
    let num = await model.query('select * from letters_num where depJc = "'+ depJc +'" AND orgJc = "'+ orgJc +'" AND year = '+ year +' AND type = "'+ type +'" AND orgID = '+ orgID +' for update')
    if (think.isEmpty(num)) {
      num = 1;
      // 在表中插入一个num
      let data = {'depJc':depJc,'orgJc':orgJc,'year':year,'type':type,'num':num,'orgID':orgID};
      const up = await model.where(where).add(data);
      await model.commit()
    }else {
      num = parseInt(num[0].num) + 1;
      // 更新表中，最新num
      const up = await model.where(where).update({'num':num,'time':moment().format('YYYY-MM-DD HH:mm:ss')});
      // const up = await model.execute('for update letters_num')
      await model.commit()
    }
    const code = depJc + orgJc + type +'[' + year + ']' + num + '号';
    return code
  }catch (e) {
    await model.rollback();
  }

  //*****************
  // let num = await think.model('letters_num').where(where).field('num').find();
  // if (think.isEmpty(num)) {
  //   num = 1;
  //   // 在表中插入一个num
  //   let data = {'depJc':depJc,'orgJc':orgJc,'year':year,'type':type,'num':num}
  //   const up = await think.model('letters_num').where(where).add(data);
  // }else {
  //   num = parseInt(num.num) + 1;
  //   // 更新表中，最新num
  //   const up = await think.model('letters_num').where(where).update({'num':num});
  // }
  // const code = depJc + orgJc + '信函字[' + year + ']' + num + '号';
  // return code
  //***********************
}
// 插入函件函号查询表
async function letterQuery(code,type,userInfo,taskId,remarkData,finalData){
  const model = think.model('letters_num_query');
  let finalDisposal = '';
  let finalDisposalID = null;
  if (typeof taskId !== 'undefined' || taskId !== ''){
    let final = await think.model('node_record').where({'taskId':taskId}).order('time DESC').select();
    if (!think.isEmpty(final)){
      for (let item of final) {
        item.info = JSON.parse(item.info);
        if (item.info.hasOwnProperty('deptName_pre') && item.info.hasOwnProperty('deptID_pre')) {
          finalDisposal = item.info.deptName_pre;
          finalDisposalID = item.info.deptID_pre;
          break;
        }
      }
    }
  }
  try {
    await model.startTrans();
    let num = await model.query('select * from letters_num_query where letterNum = "'+ code +'" for update');
    if (think.isEmpty(num)) {
      // 插入
      let data = {
        createPerson:userInfo.name,
        createAccount:userInfo.user_name,
        createOrgID:userInfo.orgID,
        createOrg:userInfo.orgName,
        depJc:userInfo.depJc,
        orgJc:userInfo.orgJc,
        type:type,
        year:moment().format('YYYY'),
        letterNum:code,
        taskId:taskId,
        from:typeof remarkData === 'undefined' ? "" : remarkData.from,
        isAnswer:typeof remarkData === 'undefined' ? "" : remarkData.isAnswer,
        remark:typeof remarkData === 'undefined' ? "" : remarkData.remark,
        finalDisposal:typeof finalData === 'undefined' ? "" : finalData.finalDisposal,
        finalDisposalID:typeof finalData === 'undefined' ? null : finalData.finalDisposalID
      };
      await model.add(data);

    }else {
      // 更新
      let data = {
        createPerson:userInfo.user_name,
        createAccount:userInfo.name,
        createOrgID:userInfo.orgID,
        createOrg:userInfo.orgName,
        depJc:userInfo.depJc,
        orgJc:userInfo.orgJc,
        type:type,
        year:moment().format('YYYY'),
        letterNum:code,
        taskId:taskId,
        from:typeof remarkData === 'undefined' ? "" : remarkData.from,
        isAnswer:typeof remarkData === 'undefined' ? "" : remarkData.isAnswer,
        remark:typeof remarkData === 'undefined' ? "" : remarkData.remark,
        finalDisposal:typeof finalData === 'undefined' ? "" : finalData.finalDisposal,
        finalDisposalID:typeof finalData === 'undefined' ? null : finalData.finalDisposalID
      };
      await model.where({'letterNum':code}).update(data);
    }
    await model.commit()
    return true;
  }catch (e) {
    await model.rollback();
  }
}
// 信访事项名称自动生成
async function getNameRule(activityID, contentClassifyID, identityTypeID, departmentID, createTime) {
  let contentClassify = contentClassifyID.toString();
  let personName = ""; // [信访人姓名]
  let anonymous = 0; //是否匿名，默认0，非匿名
  let xfName = "";// 信访名称
  // await think.model("person_activity").where({"activityID":activityID,"isMain":1,"flay":1}).find();
  let person = await think.model("person").alias('p').join("person_activity as pa on pa.personID = p.id")
    .where({"pa.activityID":activityID,"pa.isMain":1}).find();
  if (!think.isEmpty(person) && person.isAnonymous === 1 ){
    // 判断为匿名
    anonymous = 1;
  } else {
    // 非匿名
    personName = person.name;
  }

  if (contentClassify.substr(0,3) === "003"){
    // 纪检监察类
    let event = contentClassify.substr(0,9);// 纪检监察二级分类 只取了一个
    let identityType = identityTypeID.substr(0,6);// 被反映人身份二级分类
    // [纪检监察分类二级分类名]
    let eventName = await think.model("dictionary").where({"dictID":"FYN","dictValue":event,"flag":1}).find();
    // [被反映人身份二级分类名]
    let identityTypeName = await think.model("dictionary").where({"dictID":"BSF","dictValue":identityType,"flag":1}).find();
    if (anonymous === 1){
      xfName = "对" + identityTypeName.description + eventName.description + "问题的匿名反映";
      return xfName
    }else {
      xfName = personName + "对" + identityTypeName.description + eventName.description + "问题的情况反映";
      return xfName
    }
  }else {
    let department; //[反映建议涉及工作部门二级分类] .name
    let name_rule = await think.model("name_rule").where({"contentClassifyID":contentClassify,"isAnonymous":anonymous}).find();
    if (!think.isEmpty(name_rule)){
      if (contentClassify === "001006" ) {
        // 反映建议类，涉及其他方面类 的 特例
        departmentID = departmentID.substr(0,6);
        department = await think.model("bmxt").where({"dictValue":departmentID}).find();
        name_rule.name = name_rule.name.replace('[反映建议涉及工作部门二级分类]', department.name);
      }
      name_rule.name = name_rule.name.replace('[信访人姓名]', personName);
      name_rule.name = name_rule.name.replace('[登记日期]', moment(createTime).format('YYYY年M月D日'));
      name_rule.name = name_rule.name.replace('[登记或接收时间]', moment(createTime).format('YYYY年M月D日'));
    }
    xfName = name_rule.name;
    return xfName
  }
}

// 提交的时候，更新或者插入信访人历史居住地址
async function addressHistory(activityID,orgID,orgName){
  let historyAdd = [];
  let person = await think.model('person').join('person_activity ON person_activity.personID = person.id')
    .where({"person_activity.activityId":activityID}).select();
  person.forEach(async function(item) {
    let history = await think.model('address_history').where({"activityID":activityID,"personID":item.id}).select()
    let state = 0;
    history.forEach(function(h) {
      if (h.addressRegionID === item.addressRegionID && h.address === item.address){
        state += 1;
      }
    })
    if (state === 0){
      historyAdd.push({
        "personID":item.id,
        "addressRegion":item.addressRegion,
        "addressRegionID":item.addressRegionID,
        "address":item.address,
        "orgID":orgID,
        "orgName":orgName,
        "activityID":activityID,
      });
      await think.model("address_history").addMany(historyAdd);
    }
  });
}
// 判断是否为 第一个需反馈单位
async function needBack(taskId){
  // 当前所在单位级别  省级 市级 县级
  let levelNow = await think.model('fw_task').join('sys_organization on sys_organization.id = fw_task.deptID_now')
    .where({"fw_task.id":taskId}).field('fw_task.*,sys_organization.isRenDa').find();
  if (think.isEmpty(levelNow)){
    return false;
  } else {
    let upperLevel = "";
    if (levelNow.isRenDa === 0){
      // 是职能单位 查同级人大
      upperLevel = levelNow.regionLevel_now
    }else {
      // 查询上级单位办理方式，省级没有上级单位
      if (levelNow.regionLevel_now === '市级'){
        // 当前是 市级 ，去查省级办理方式
        upperLevel = '省级';
      } else if (levelNow.regionLevel_now === '县级'){
        // 当前是 县级 , 去查市级办理方式
        upperLevel = '市级';
      } else {
        // 当前是 省级 或 其他错误结果
        upperLevel = ""
      }
    }
    const levelNowDealtypeSql = 'SELECT dealType from fw_task_act LEFT JOIN fw_act on fw_task_act.actno = fw_act.id ' +
      'where fw_task_act.c_task = ' + taskId + ' and fw_task_act.regionLevel_now  = "' + upperLevel + '" ' +
      'and fw_act.dealType is not NULL and fw_act.dealType != "" order by fw_task_act.id desc limit 1';
    let dealType = await think.model('fw_task_act').query(levelNowDealtypeSql);
    if (dealType.length === 0 || (dealType.dealType !== '交办' && dealType.dealType !== '转交')){
      return true
    } else {
      return false
    }
  }
}

// 生成接谈单位排队号
async function getRoomCodeNum(orgID){
  // 查找接谈室
  const model = think.model('meeting_room');
  try {
    await model.startTrans();
    let res = await model.query("select * from meeting_room where roomOrgID = " + orgID + " for update");
    if (think.isEmpty(res)){
      await model.commit()
    } else {
      // 找到接谈室
      let code;
      if (res[0].roomCodeNum === null){
        code = "001";
      } else {
        let str = "000" + (res[0].roomCodeNum + 1).toString();
        code =  str.substring(str.length - 3);
      }
      await model.where({'id':res[0].id}).update({'roomCodeNum':parseInt(code)});
      await model.commit();
      return code;
    }
  }catch (e) {
    await model.rollback()
  }
}
// 保存接谈排号单
// async function saveQueue(roomCodeNum,taskId,orgID){
async function saveQueue(taskId,orgID){
  let matter = await think.model('matter').where({'taskid':taskId}).find();
  let queue = await think.model('queue').where({'matterID':matter.id}).find();
  let room = await think.model('meeting_room').where({'roomOrgID':orgID}).find();
  if (think.isEmpty(matter) || think.isEmpty(room)){
    return false
  } else if (queue.roomOrgID === orgID) {// 这个事项已经安排过这个接谈室，不再进行排号
    return false
  } else {
    let roomCodeNum = await getRoomCodeNum(orgID);
    let contentClassifyAll = ""; // 问题分类全称
    let cc = matter.contentClassifyID.split(',');// 问题分类
    let ccaID = matter.contentClassifyID;
    if (cc[0].substr(0,3) === '003') {
      // 如果是纪检监察类多选
      // 判断是否有contentClassifyMain，如果没有，取第一个，且要更新matter
      if (matter.contentClassifyMainID === null || matter.contentClassifyMainID === ''){
        ccaID = cc[0];
        await think.model('matter').where({'id':matter.id}).update({'contentClassifyMainID':ccaID});//名称不赋值了，可能对不上
      }else {
        ccaID = matter.contentClassifyMainID
      }
    }
    let level1 = ccaID.substr(0,3);
    let level2 = ccaID.substr(0,6);
    let level3 = ccaID.substr(0,9);
    let level4 = ccaID.substr(0,12);
    let level5 = ccaID.substr(0,15);
    async function L1(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':level1}).find();
      return think.isEmpty(back) ? "" : back.description;
    }
    async function L2(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':level2}).find();
      return think.isEmpty(back) ? "" : back.description
    }
    async function L3(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':level3}).find()
      return think.isEmpty(back) ? "" : back.description
    }
    async function L4(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':level4}).find()
      return think.isEmpty(back) ? "" : back.description
    }
    async function L5(){
      let back = await think.model('dictionary').where({'dictID':'FYN','dictValue':level5}).find()
      return think.isEmpty(back) ? "" : back.description
    }
    let all = await Promise.all([L1(),L2(),L3(),L4(),L5()]);
    contentClassifyAll = all[0]+'-'+all[1]+'-'+all[2]+'-'+all[3]+'-'+all[4];
    contentClassifyAll = contentClassifyAll.substr(0,contentClassifyAll.lastIndexOf('-'));
    let data = {
      'meetingID':matter.meetingID,// 大会届次ID
      'roomID':room.id,// 接谈室id
      'roomName':room.room,// 接谈室名称
      'roomOrgName':room.roomOrg,// 接谈室单位
      'roomOrgID':room.roomOrgID,// 接谈室单位ID
      'roomCode':room.roomCode,// 接谈室代号
      'roomCodeNum':roomCodeNum,// 等候排序号，这里存是是字符串
      'matterID':matter.id,// 事项id
      'matterNum':matter.matterNum,// 事项编号
      'personID':matter.activity.mainPerson,// 首登记人id
      'personName':matter.activity.person.name,// 首登记人
      'IDType':matter.activity.person.IDType,// 证件类型
      'IDTypeID':matter.activity.person.IDTypeID,// 证件类型编号
      'IDNumber':matter.activity.person.IDNumber,// 证件类型编号
      'addressRegion':matter.activity.person.addressRegion,// 现住地址所属地区
      'addressRegionID':matter.activity.person.addressRegionID,// 现住地址所属地区字典编号
      'address':matter.activity.person.address,// 现住详细地址
      'abstract':matter.abstract,// 信访摘要
      'contentClassifyAll':contentClassifyAll,// 所属内容分类全称
      'contentClassify':cc[0].substr(0,3) === '003' ? matter.contentClassifyMain : matter.contentClassify,// 所属内容分类，纪检监察只记录主要问题
      'contentClassifyID':cc[0].substr(0,3) === '003' ? matter.contentClassifyMainID : matter.contentClassifyID,// 所属内容分类ID，纪检监察只记录主要问题
    }
    // 插入等待接谈排号单
    await think.model('queue').add(data);
  }
  return true
}
// 初始化接谈处理单
async function addTalkingHandle(taskId,queueID){
  let findHandle = await think.model('talking_handle').where({'queueID':queueID}).find();
  if (!think.isEmpty(findHandle)){
    // 已经初始化过了
    return true
  }
  let matter = await think.model('matter').where({'taskid':taskId}).find();
  let queue = await think.model('queue').where({'id':queueID}).find();
  let handleAdd = {
    "meetingID":queue.meetingID,
    "queueID":queueID,
    "roomID":queue.roomID,
    "roomName":queue.roomName,
    "roomOrgID":queue.roomOrgID,
    "roomOrgName":queue.roomOrgName,
    "roomCode":queue.roomCode,
    "roomCodeNum":queue.roomCodeNum,
    "matterID":queue.matterID,
    "matterNum":queue.matterNum,
    "personID":queue.personID,
    "personName":queue.personName,
    "identity":matter.activity.person.identity,
    "identityID":matter.activity.person.identityID,
    "idCardRegion":matter.activity.person.idCardRegion,
    "idCardAddress":matter.activity.person.idCardAddress,
    "idCardRegionID":matter.activity.person.idCardRegionID,
    "IDType":matter.activity.person.IDType,
    "IDTypeID":matter.activity.person.IDTypeID,
    "IDNumber":matter.activity.person.IDNumber,
    "addressRegion":matter.activity.person.addressRegion,
    "addressRegionID":matter.activity.person.addressRegionID,
    "address":matter.activity.person.address,
    "domicile":matter.activity.person.domicile,
    "domicileID":matter.activity.person.domicileID,
    "xfNumber":matter.activity.xfNumber,
    "xfSource":matter.activity.xfSource,
    "xfSourceID":matter.activity.xfSourceID,
    "phone":matter.activity.person.mobilePhone,
    "happenRegion":matter.happenRegion,
    "happenRegionID":matter.happenRegionID,
    "belongs":(matter.belongsID.substr(0,3) === '001') ? '人大' : matter.belongs,
    "belongsID":(matter.belongsID.substr(0,3) === '001') ? '001' : matter.belongsID,
    "lfReason":matter.lfReason,
    "lfReasonID":matter.lfReasonID,
    "contentClassify":queue.contentClassify,
    "contentClassifyID":queue.contentClassifyID,
    "contentClassifyAll":queue.contentClassifyAll,
    "abstract":queue.abstract,
  }
  let handle = await think.model('talking_handle').add(handleAdd);
  return handle;
}
// 生成告知单号
async function getTellNum(regionAdminNo){
  let TellNum = "";
  let zoneUnit = regionAdminNo;
  let sql = "select * from tell_code where zoneUnit='" + zoneUnit + "' for update";
  let res = await think.model('tell_code').query(sql);
  const tYear = getCurrentYear();// 获取年份
  if (res.length > 0) {
    let eidtParam = {
      zoneUnit: zoneUnit,
      yearNum: tYear,
      serialNum: 1,
      id: res[0].id
    }
    TellNum = zoneUnit + tYear + "00001";
    if (res[0].yearNum == tYear) {
      let str = "00000" + (res[0].serialNum + 1).toString();
      let serialNum =  str.substring(str.length - 5);
      eidtParam.serialNum = res[0].serialNum + 1;
      TellNum = zoneUnit + tYear + serialNum
    }
    //修改数据库
    await think.model('tell_code').where({
      id: eidtParam.id
    }).update(eidtParam).catch((err) => {
      return think.isError(err) ? err : new Error(err);
    });
  } else {
    TellNum = zoneUnit + tYear + "00001";
    let insertParam = {
      zoneUnit: zoneUnit,
      yearNum: tYear,
      serialNum: 1
    };
    //新增数据库
    await think.model('tell_code').add(insertParam).catch((err) => {
      return think.isError(err) ? err : new Error(err);
    });
  }
  return TellNum;
}

//将数组根据条件分组
function groupTreeByParam(list, param){
  var data = [];
  // [ {key:"key",list:[]} ]
  if(list && list.length > 0){
    for(var i = 0; i < list.length; i++){
      if(param){
        var res = list[i][param]
      }

      let length = 0;
      for (let item of data){
        if (item["key"] === res){
          item['list'].push(list[i])
          break;
        }
        length += 1;
      }
      if (length === data.length) {
        data.push({
          "key":res,"list":[list[i]]
        });
      }
    }
  }
  return data;
}

async function fullName(dictID,dictValue){
  async function L1(){
    let back = await think.model('dictionary').where({'dictID':dictID,'dictValue':dictValue.substr(0,3)}).find();
    return think.isEmpty(back) ? "" : back.description;
  }
  async function L2(){
    let back = await think.model('dictionary').where({'dictID':dictID,'dictValue':dictValue.substr(0,6)}).find();
    return think.isEmpty(back) ? "" : back.description
  }
  async function L3(){
    let back = await think.model('dictionary').where({'dictID':dictID,'dictValue':dictValue.substr(0,9)}).find();
    return think.isEmpty(back) ? "" : back.description
  }
  async function L4(){
    let back = await think.model('dictionary').where({'dictID':dictID,'dictValue':dictValue.substr(0,12)}).find();
    return think.isEmpty(back) ? "" : back.description
  }
  async function L5(){
    let back = await think.model('dictionary').where({'dictID':dictID,'dictValue':dictValue.substr(0,15)}).find();
    return think.isEmpty(back) ? "" : back.description
  }
  let all = await Promise.all([L1(),L2(),L3(),L4(),L5()]);
  let name = all[0]+'-'+all[1]+'-'+all[2]+'-'+all[3]+'-'+all[4];
  name = name.substr(0,name.lastIndexOf('-'));
  return name
}

// 验证异常信访活动记录，插入异常表
async function abnormal(taskId){
  let activity = await think.model('activity').join('matter on matter.activityID = activity.id')
    .where({'matter.taskid':taskId}).field('activity.*,matter.id as matterID,matter.matterNum').find();
  if (think.isEmpty(activity)) {
    return false
  }
  let abnormal = await think.model('abnormal').where({"matterNum":activity.matterNum}).find();
  if (!think.isEmpty(abnormal)) {
    return false
  }
  let data = {
    "activityID":activity.id,
    "matterID":activity.matterID,
    "matterNum":activity.matterNum,
    "djTime":activity.createTime,
    "xfSource":activity.xfSource,
    "xfNature":activity.xfNature,
    "xfType":activity.xfType,
    // "typeName":"",
    "registerType":activity.registerType,
    "createOrgID":activity.createOrgID,
    "createOrgName":activity.createOrg,
    "djUserName":activity.createPerson,
  };
  if (activity.xfTypeID === '001002' || activity.xfTypeID === '001003') {
    //   ①集体访登记
    data['typeName'] = "集体访"
  }
  if (activity.xfTypeID === '002002' ) {
    //   ②联名信登记
    data['typeName'] = "联名信"
  }
  if (activity.registerTypeID === '001' && activity.isAbnormal === 1) {
    //   ③异常访登记
    data['typeName'] = "异常访"
  }
  if (activity.registerTypeID === '002' && activity.isAbnormal === 1 && activity.abnormalID.indexOf("002001") >= 0) {
    //   ④扬言信登记
    data['typeName'] = "扬言信"
  }
  if (data.hasOwnProperty("typeName")){
    await think.model('abnormal').add(data);
  }
  return true
}

// 判断活动初重状态
async function isActivityVisit(activity){
  // 同人，同事，同单位，同信访形式
  let activityID = activity.id;
  let registerTypeID = activity.registerTypeID;
  let orgID = activity.createOrgID;
  let personID = activity.personID.split(',');
  let m = await think.model('matter').setRelation(false).where({'activityID':activityID,'visitID':'200'}).select();
  if (think.isEmpty(m)){
    // 事项中没有重复事项
    return '初次'
  } else {
    // 事项重复，进一步判断
    let ac = await think.model('activity').setRelation(false).where({'createOrgID':orgID,'registerTypeID':registerTypeID,'id':['!=',activityID]}).select();
    if (think.isEmpty(ac)){
      return '初次'
    }else {
      // 在同单位，同信访形式下 ，进一步判断信访人是否有重复
      let acP = [];
      ac.forEach(function(item) {
        acP = acP.concat(item.personID.split(','))
      });
      if (personID.length > 0 && acP.length > 0){
        newA = new Set(personID);
        newB = new Set(acP);
        let arrSet = new Set([...newA].filter(x => newB.has(x)));
        let arr = Array.from(arrSet);//判断数组是否有交集
        return (arr.length > 0 ? '重复' : '初次');
      }else {
        return '初次'
      }
    }
  }
}
async function DH_window_add(activityID,personID,userID){
  // 查询 大会活动，来访，统一接待点，当天登记，主信访人，未提交
  let sql_ac = "SELECT p.idCardRegionID FROM activity AS a LEFT JOIN person AS p ON p.id = a.mainPerson WHERE a.isMeeting = 0 AND" +
    " a.registerPlaceID = '1' AND a.registerTypeID = '001' AND TO_DAYS(a.createTime) = TO_DAYS(NOW()) AND a.submit = 0 " +
    "AND p.id = "+ personID +" AND a.id = '" + activityID +"' ORDER BY a.createTime DESC LIMIT 0,1";
  let res_ac = await think.model('activity').setRelation(false).query(sql_ac);
  // 身份证有值
  if (!think.isEmpty(res_ac) && res_ac[0].idCardRegionID !== "" && res_ac[0].idCardRegionID !== null){
    // 查询 省市县
    let sql_dic = "SELECT description AS a,IFNULL((SELECT description FROM dictionary WHERE dictID = 'DQ' AND dictValue = '"
      +res_ac[0].idCardRegionID.substr(0,6)+"'),NULL) AS b," +
      " IFNULL((SELECT description FROM dictionary WHERE dictID = 'DQ' AND dictValue = '"+
      res_ac[0].idCardRegionID.substr(0,9)+"'),NULL) AS c " +
      " FROM dictionary WHERE dictID = 'DQ' AND dictValue = '" +res_ac[0].idCardRegionID.substr(0,3)+"'";
    let res_dic = await think.model('dictionary').query(sql_dic);
    if (!think.isEmpty(res_dic)){
      // 更新register_window
      let up ={
        'area_name':res_dic[0].a + (res_dic[0].b === null ? '' : res_dic[0].b) + (res_dic[0].c === null ? '' : res_dic[0].c),
        'first_area_name':res_dic[0].a,
        'second_area_name':res_dic[0].b === null ? null : res_dic[0].b,
        'third_area_name':res_dic[0].c === null ? null : res_dic[0].c,
        'status':1
      };
      //指定userID才更新
      await think.model('register_window').where({'user_id':userID}).update(up);
    }
  }
  return true
}
async function DH_window_up(userID){
  // 指定userID才更新
  await think.model('register_window').where({'user_id':userID}).update({'status':0});
  return true
}
module.exports = {
  getNamespaceByNameRules,
  getActivityNo,
  getActivityNum,
  getPersonNum,
  perActMoreAct,
  perActLessAct,
  getCurrentYear,
  matterQueryCode,
  judgeState,
  letterNum,
  letterQuery,
  getNameRule,
  addressHistory,
  getMatterNo,
  needBack,
  getRoomCodeNum,
  saveQueue,
  addTalkingHandle,
  getTellNum,
  groupTreeByParam,
  fullName,
  abnormal,
  isActivityVisit,
  DH_window_add,
  DH_window_up
}
