module.exports = class extends think.Logic {
  indexAction() {

  }
  addAction() {
    this.allowMethods = 'post';
    const rules = {
      url: {
        array: true,
        default: []
      },
      isAbnormal: {
        int: true,
        default: 0 // 默认正常
      },
      personID: {
        array: true,
        default: []
      },
      matterID: {
        array: true,
        default: []
      },
      abnormalID: {
        array: true,
        default: []
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  listAction() {
    this.allowMethods = 'post';
    const rules = {
      limit: {
        int: true, // 字段类型为 int 类型
        default: 10 // 默认值
      },
      page: {
        int: true, // 字段类型为 int 类型
        default: 0 // 默认值
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  findAction() {
    this.allowMethods = 'post';
    const rules = {
      id: {
        string: true, // 字段类型为 string 类型
        required: true // 必填项
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  delLeadingAction() {
    this.allowMethods = 'post';
    const rules = {
      leadingID: {
        required: true,
        int: true,
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  editLeadingPersonAction() {
    this.allowMethods = 'post';
    const rules = {
      leadingID: {
        required: true,
        int: true,
      },
      unit: {
        string: true,
        default: ""
      },
      name: {
        string: true,
        default: ""
      },
      IDcard: {
        string: true,
        default: ""
      },
      sex: {
        string: true,
        default: ""
      },
      position: {
        string: true,
        default: ""
      },
      grade: {
        string: true,
        default: ""
      },
      due: {
        string: true,
        default: ""
      },
      zone: {
        string: true,
        default: ""
      },
      isLeading: {
        int: true,
        default: null
      } 
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }  
  }

  addLeadingPersonAction() {
    this.allowMethods = 'post';
    const rules = {
      unit: {
        string: true,
        default: ""
      },
      name: {
        string: true,
        default: ""
      },
      IDcard: {
        string: true,
        default: ""
      },
      sex: {
        string: true,
        default: ""
      },
      position: {
        string: true,
        default: ""
      },
      grade: {
        string: true,
        default: ""
      },
      due: {
        string: true,
        default: ""
      },
      zone: {
        string: true,
        default: ""
      },
      isLeading: {
        int: true,
        default: null
      }
      
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }  
  }
};
